UNIT StdHdr;

interface

CONST maxr = 100;
      maxc = 50;
      maxv = 256;

TYPE
    Ptr_Int = ^INTEGER;
    string80  = string[ 80 ];
    OpType = (plus,minus,multiply,divide,invert,cmod);
    ComplexType = record
                     r: double;
                     i: double;
                   end;
    ShortVector  =          ARRAY[0..maxc] of double;
    LongVector   =          ARRAY[0..maxr] OF double;
    CShortVector  =         ARRAY[0..maxc] of ComplexType;
    CLongVector   =         ARRAY[0..maxr] OF ComplexType;
    VeryLongVector =        ARRAY[0..maxv] of double;
    ShortIntegerVector =    ARRAY[0..maxr] of integer;
    Recmat  =               ARRAY[0..maxr] OF ShortVector;
    Sqrmat  =               ARRAY[0..maxc] OF ShortVector;
    CRecmat  =              ARRAY[0..maxr] OF CShortVector;
    CSqrmat  =              ARRAY[0..maxc] OF CShortVector;
    strVector =             ARRAY[0..maxc] of string80;
    FileNameType =          string80;
    TitleStr =              string80;

    regtype = record
                 ax,bx,cx,dx,bp,si,di,ds,es,flags:integer;
               end;

IMPLEMENTATION

END.
