unit Unit6;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, ComCtrls, clipbrd, Buttons, printers, math;

type
  Tform6 = class(TForm)
    Panel1: TPanel;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    Edit4: TEdit;
    Image1: TImage;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn3: TBitBtn;
    OpenDialog1: TOpenDialog;
    BitBtn4: TBitBtn;
    BitBtn2: TBitBtn;
    RadioGroup1: TRadioGroup;
    BitBtn5: TBitBtn;
    PopupMenu2: TPopupMenu;
    DiffracATFileRAW1: TMenuItem;
    RietveldFileDAT1: TMenuItem;
    CPIFileCPI1: TMenuItem;
    Label1: TLabel;
    Label4: TLabel;
    PhilipsFormatrd1: TMenuItem;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure init_crea(Sender: TObject);
    procedure dessine_spectre(Sender: TObject);
    procedure affiche_theta(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure lit_fichier_brucker(Sender: TObject);
    procedure undisplay_edit8(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure echelle_modi(Sender: TObject; var AllowChange: Boolean);
    procedure shifte_diagramme(Sender: TObject; var AllowChange: Boolean);
    procedure init_active(Sender: TObject);
    procedure reset_dessin(Sender: TObject);
    procedure raze_selection(Sender: TObject);
    procedure change_theta_2theta(Sender: TObject);
    procedure efface_diagramme_raw(Sender: TObject);
    procedure charge_spectre(Sender: TObject);
    procedure lit_fichier_rietfeld(Sender: TObject);
    procedure lit_fichier_cpi(Sender: TObject);
    procedure MouseUp_image1(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure souris_onmouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lit_fichier_philips(Sender: TObject);
    procedure imprime_ecran(Sender: TObject);
    procedure change_extinc(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  form6: Tform6;

procedure dessin;
procedure automatic_select;
Procedure ecrit_stringgrid3;
procedure efface_stringGrid3;
procedure lecture_fichier_raw(num: integer);
//procedure ordre_raies_obs;
implementation

{$R *.DFM}

uses
  mathhkl, fichiers, Unit1, unit3, unit3b, unit4, unit2, unit5, truecell
  , lilambda, best_sol;

var
   x_zero,y_zero,pos0                       : integer;
   echx,echy,theta1,theta2,facteur_echelle  : real;
   flag_click,flag_zoom                     : boolean;
   x_av,y_av,x_down,y_down,x_up,y_up        : integer;
   souris_down                              : boolean;
   theta_min_av,theta_max_av                : real;

procedure Tform6.init_crea(Sender: TObject);
//-----------------------------------------
var
   hmenu          : integer;
   s              : string;
begin
  if (screen.height > 600) and (screen.Width > 800) then begin
    HorzScrollBar.visible:=false;
    VertScrollBar.visible:=false;
  end;
  //if (screen.width = 800)then form6.ScaleBy(77,100);
  label2.caption:='';
  label3.caption:='';
  label1.caption:='';
  left:=0;
  top:=456;
  width:=1020;
  height:=280;
  panel1.color:=$00F4FFE1;
  hmenu:=15;
  image1.top:=hmenu;
  image1.left:=0;
  image1.width:=Width;
  image1.height:=clientHeight-panel1.height-2*hmenu;

  panel1.top:=image1.height+2*hmenu;
  panel1.left:=0;
  panel1.width:=clientwidth;

  facteur_echelle:=1;
  numero4:=-1;
  numero5:=-1;

  tolerance:=0.15;
  updown1.position:=180;
  pos0:=180;
  str(tolerance:6:3,s);
  form1.edit26.text:=s;
  form1.edit37.text:=s;
  flag_click:=false;flag_zoom:=false;
end;

procedure cmtopx(xcm,ycm:real; var px,py:integer);{
--------------------------------------------------}
begin
  px:=round((xcm-theta1)*echx)+x_zero;
  py:=form6.image1.height-round(ycm*echy)-y_zero;
end;

procedure pxtocm(px,py:integer; var xcm,ycm:real);{
--------------------------------------------------}
begin
  xcm:=(px-x_zero)/echx+theta1;
  ycm:=(form6.image1.height-py-y_zero)/echy;
end;

procedure tras(x,y: real; i :integer);{
--------------------------------------}
var
  ix,iy  : integer;
begin
  cmtopx(x,y,ix,iy);
  if (iy < 1)then iy:=1;
  if (i = 1) then form6.image1.canvas.lineto(ix,iy);
  if (i = 0) then form6.image1.canvas.moveto(ix,iy);
end;

{Trac de l'axe des X}
procedure axex(x1,y1,x2:real);{
--------------------------------}
var
  d,dx,x                                  : real;
  ix,iy,i                                 : integer;
  s                                       : string;
  label lab1;

begin
  {Espacement des graduations}
  d:=10;
  dx:=abs(x2-x1);
  if(dx < 0.1)                then d:=0.01;
  if(dx > 0.5) and (dx <= 1)  then d:=0.1;
  if(dx > 1)   and (dx <= 10) then d:=1;
  if(dx > 10)  and (dx <= 50) then d:=5;
  if(dx > 50)  and (dx <= 100)then d:=10;
  if(dx > 100)                then d:=20;

  {Trac des graduations}
   tras(x1,y1,0);
   tras(x2,y1,1);
   i:=round(x1/d);
   dx:=i;
   x:=dx*d;
   if (x < x1) then x:=x+d;
   while (x <= x2) do begin
     tras(x,y1,0);
     cmtopx(x,y1,ix,iy);

     {Quadrillage}
     form6.image1.canvas.moveto(ix,iy);
     form6.image1.canvas.lineto(ix,iy+5);

     {Si x est suprieur  100, on change de format}
     if (x >= 100) then begin
        str(x:5:1,s);
     end else begin
        str(x:5:1,s);
     end;
     form6.image1.canvas.textout(ix-10,iy+5,s);
     x:=x+d;
   end;
end;

procedure dessin;
//--------------
var
   i,j,ix,iy,h,k,l,ier                  : integer;
   xx,yy,dtheta,x,y,ang_calc,ang_obs    : real;
   s                                    : string;

   tabxy                     : array[1..1020] of tpoint;
   nn,n1,n2                  :integer;
   i0,kk                     : real;
begin
  x_zero:=3;
  y_zero:=50;

//Effacement image1
  with form6 do begin
    image1.refresh;
    image1.canvas.pen.color:=clblack;
    image1.canvas.brush.color:=clwhite;
    image1.canvas.Rectangle(0,0,image1.width-1,image1.height-1);
  end;
  if (theta_max = 0)then exit;

//Limites du diagramme
  with form6 do begin
    if(RadioGroup1.itemIndex = 0)then begin
      dtheta:=0.5*(theta_max-theta_min);
      theta1:=0.5*theta_min;
      theta2:=0.5*theta_max;
    end else begin
      dtheta:=(theta_max-theta_min);
      theta1:=theta_min;
      theta2:=theta_max;
    end;

//Modif mai 2002    
    theta1:=theta1-0.025*dtheta;
    theta2:=theta2+0.025*dtheta;
    dtheta:=dtheta*1.05;

//Echelles
    echx:=(image1.width-2)/dtheta;
    echy:=facteur_echelle*(image1.height-y_zero)/100;
    axex(theta1,0,theta2);

    if(nb_raies_indx > 0)then begin
      for i:=1 to nb_raies_indx do begin
        with raies_indx[i] do begin
          h:=hr;k:=kr;l:=lr;
          extinc(h,k,l,ier);
          ext:=ier;
          if (ier = 1) and (bravais = 'R')then begin
            extinc(k,h,l,ier);
            ext:=ier;
          end;
        end;
      end;
      label3.top:=panel1.top-15;
      if (nom_fichier_ind = '')then
      label3.caption:='Calculated reflections '  else
      label3.caption:='Calculated reflections: '+extractFileName(nom_fichier_ind);

//Systme orthorhombique, setting?
       if (systeme = 'ORTH')then begin
         for i:=1 to 3 do
         for j:=1 to 3 do r[i,j]:=oabc[no_setting,i,j];
         for i:=1 to nb_raies_indx do begin
           with raies_indx[i] do begin
             h:=r[1,1]*hr+r[1,2]*kr+r[1,3]*lr;
             k:=r[2,1]*hr+r[2,2]*kr+r[2,3]*lr;
             l:=r[3,1]*hr+r[3,2]*kr+r[3,3]*lr;
             extinc(h,k,l,ier);
             ext:=ier;
           end;
         end;
       end;

//Raies teintes
       image1.canvas.pen.color:=clgreen;
       if (form6.speedButton2.down = false) and (nb_raies_indx_eteint > 0) then begin
         image1.Canvas.Pen.style:=psdot;
         for i:=1 to nb_raies_indx_eteint do begin
           //if (raies_indx_eteint[i].ext = 0) then continue;
           xx:=raies_indx_eteint[i].dtheta;
           if(RadioGroup1.itemIndex = 0)then xx:=0.5*xx;
           if(xx < theta1)then continue;
           if(xx > THETA2)then break;
           cmtopx(xx,0,ix,iy);
           image1.canvas.moveto(ix,iy);
           image1.canvas.lineto(ix,image1.height-1);
         end;
       end;

//Partie theta < 0?
       if (theta1 < 0)then begin
         if (form6.speedButton2.down = false) and (nb_raies_indx_eteint > 0) then begin
           image1.Canvas.Pen.style:=psdot;
           for i:=1 to nb_raies_indx_eteint do begin
             //if (raies_indx_eteint[i].ext = 0) then continue;
             xx:=-raies_indx_eteint[i].dtheta;
             if(RadioGroup1.itemIndex = 0)then xx:=0.5*xx;
             if(xx < theta1)then continue;
             if(xx > THETA2)then break;
             cmtopx(xx,0,ix,iy);
             image1.canvas.moveto(ix,iy);
             image1.canvas.lineto(ix,image1.height-1);
           end;
         end;
       end;

//Raies allumes
       image1.Canvas.Pen.style:=pssolid;
       for i:=1 to nb_raies_indx do begin
         if (raies_indx[i].ext = 1) then continue;
         xx:=raies_indx[i].dtheta;
         if(RadioGroup1.itemIndex = 0)then xx:=0.5*xx;
         if(xx < theta1)then continue;
         if(xx > THETA2)then break;
         cmtopx(xx,0,ix,iy);
         image1.canvas.moveto(ix,iy);
         image1.canvas.lineto(ix,image1.height-1);
       end;

//Partie theta < 0?
       if (theta1 < 0)then begin
         for i:=1 to nb_raies_indx do begin
           if (raies_indx[i].ext = 1) then continue;
           xx:=-raies_indx[i].dtheta;
           if(RadioGroup1.itemIndex = 0)then xx:=0.5*xx;
           if(xx < theta1)then continue;
           if(xx > THETA2)then break;
           cmtopx(xx,0,ix,iy);
           image1.canvas.moveto(ix,iy);
           image1.canvas.lineto(ix,image1.height-1);
         end;
       end;
    end;

//Dessin ventuel du spectre RAW
    if(length(nom_fichier_raw) > 0)then begin
      label1.top:=label2.top;
      label1.color:=clwhite;
      label1.font.color:=clred;
      s:='Observed profile: '+extractFileName(nom_fichier_raw);
      label1.left:=panel1.width-2-canvas.TextWidth(s);
      label1.caption:=s;
      image1.canvas.pen.color:=clred;
      //Dtermination des premier et dernier point
      image1.canvas.pen.color:=clblack;
      for i:=1 to nb_raies_raw do begin
        if (x_theta[i] >= theta_min)then begin
          n1:=i;
          break;
        end;
      end;
      for i:=nb_raies_raw downto 1 do begin
        if (x_theta[i] <= theta_max)then begin
          n2:=i;
          break;
        end;
      end;
      
//Interpolation pour ramener nb_raies_raw points a nn points
      //nn:=ftruecell.image1.width-2;
      nn:=1020;
      i0:=(n1*nn-n2)/(nn-1);
      kk:=(n2-n1)/(nn-1);
      for i:=1 to nn do begin
         yy:=y_intensite[round(i0+kk*i)];
         xx:=x_theta[round(i0+kk*i)];
         if (form1.radiogroup1.itemIndex = 0)then xx:=0.5*xx;
         cmtopx(xx,yy,ix,iy);
         tabxy[i]:=point(ix,iy);
      end;
      image1.canvas.polyline(slice(tabxy,nn));
      image1.canvas.pen.color:=clblack;
    end;

//Dessin du spectre DIF
    if (nb_raies_dif > 0)then begin
      label2.top:=0;
      label2.color:=clwhite;
      label2.caption:='Measured reflections: '+extractFileName(nom_fichier_dif);
      for i:=1 to nb_raies_dif do begin
         x:=theta_dif[i];
         if(RadioGroup1.itemIndex = 0)then x:=0.5*x;
         cmtopx(x,0,ix,iy);
         image1.canvas.pen.color:=clgray;
         image1.canvas.moveto(ix,iy);
         image1.canvas.lineto(ix,1);
         y:=intensite_dif[i];         //image1.canvas.pen.width:=3;
         image1.canvas.pen.color:=clblack;
         tras(x,0,0);
         tras(x,y,1);                //image1.canvas.pen.width:=1;
      end;
      image1.canvas.pen.color:=clblack;
    end;

//Marquage ventuel des numros de raies slectionnes
    if (nb_raies_obs > 0)then begin
      image1.canvas.brush.color:=clyellow;
      for i:=1 to nb_raies_obs do begin
        ang_obs:=dtheta_obs[i];
        ang_calc:=dtheta_calc[i];
        if(RadioGroup1.itemIndex = 0)then begin
          ang_obs:=0.5*ang_obs;
          ang_calc:=0.5*ang_calc;
        end;
        cmtopx(0.5*dtheta_obs[i],0,ix,iy) ;

        h:=image1.height;
        with image1.canvas do begin
           cmtopx(ang_obs,0,ix,iy);
           textout(ix-4,15,IntToStr(i));
           if (i = no_select_raie)then pen.color:=clred else pen.color:=clblue;
           //pen.color:=clblue;
           moveto(ix,iy);
           lineto(ix,15);
           cmtopx(ang_calc,0,ix,iy);
           textout(ix-4,h-15,Inttostr(i));
           if (i = no_select_raie)then pen.color:=clred else pen.color:=clblue;
           moveto(ix,iy);
           lineto(ix,h-15);
           pen.color:=clblack;
        end;
      end;
    end;
  end;
end;

procedure ordre_raies_obs;{
--------------------------}
var
  i,j,h,k,l                : integer;
  dd                       : real;
begin
  if(nb_raies_obs < 2) then exit;
  for i:=1 to nb_raies_obs -1 do begin
    for j:=i+1 to nb_raies_obs do begin
      if (dtheta_obs[i] > dtheta_obs[j]) then begin
        dd:=dtheta_obs[i];
        dtheta_obs[i]:=dtheta_obs[j];
        dtheta_obs[j]:=dd;
        dd:=dtheta_calc[i];
        dtheta_calc[i]:=dtheta_calc[j];
        dtheta_calc[j]:=dd;
        h:=h_obs[i];
        h_obs[i]:=h_obs[j];
        h_obs[j]:=h;
        k:=k_obs[i];
        k_obs[i]:=k_obs[j];
        k_obs[j]:=k;
        l:=l_obs[i];
        l_obs[i]:=l_obs[j];
        l_obs[j]:=l;
      end;
    end;
  end;
end;

Procedure ecrit_stringgrid3;{
----------------------------}
var
  s,s1,s2,s3  : string;
  i,j         : integer;
  //nomf :textfile;
begin
  //affichage dans raies_obs_grid (stringgrid3)
  with form1.stringGrid3 do begin
    rowcount:=nb_raies_obs+2;
    for I := 0 to ColCount - 1 do
      for J:= 0 to RowCount - 1 do
        Cells[I,J] := '';
  end;
  with form1.stringGrid3 do begin
    colwidths[0]:=25;
    for i:=1 to 4 do colwidths[i]:=42+4;
    cells[0,0]:='Nb.';
    cells[1,0]:='h   k   l';
    if (form6.RadioGroup1.ItemIndex = 1) then begin
      cells[2,0]:='2T Obs';
      cells[3,0]:='2T Calc';
    end else begin
      cells[2,0]:='T Obs';
      cells[3,0]:='T Calc';
    end;
    cells[4,0]:='Diff.';
    //assignfile(nomf,'data.inp');
    //rewrite(nomf);
    for i:=1 to nb_raies_obs do begin
      str(i:2,s);
      cells[0,i]:=s;
      str(h_obs[i]:3,s1);
      str(k_obs[i]:3,s2);
      str(l_obs[i]:3,s3);
      cells[1,i]:=s1+s2+s3;
      //write(nomf,s1+s2+s3);
      //writeln(nomf,dtheta_obs[i]:10:3);
      if (form6.RadioGroup1.ItemIndex = 1) then str(dtheta_obs[i]:8:3,s)
      else str(0.5*dtheta_obs[i]:8:3,s);
      cells[2,i]:=s;
      if (form6.RadioGroup1.ItemIndex = 1) then str(dtheta_calc[i]:8:3,s)
      else str(0.5*dtheta_calc[i]:8:3,s);
      cells[3,i]:=s;
      if (form6.RadioGroup1.ItemIndex = 1) then
      str((dtheta_obs[i]-dtheta_calc[i]):8:3,s) else
      str(0.5*(dtheta_obs[i]-dtheta_calc[i]):8:3,s);
      cells[4,i]:=s;
    end;
  end;
  ecrit_stringgrid8;
end;

procedure Tform6.dessine_spectre(Sender: TObject);
//------------------------------------------------
begin
  dessin;
end;

//Slection automatique
procedure automatic_select;
//------------------------
var
  ang_calc,ang_obs,sigma                                 : real;
  dist,dist_min                                          : real;
  i,j,k,n,i_raie,ier                                     : integer;
  s                                                      : string;
  nomf                                                   : textfile;
label 1;
begin
    s:=form1.edit26.text;
    val(s,tolerance,ier);
    if (ier > 0)then begin
      erreur('Error (angular tolerance)');
      exit;
    end;
    if (form6.RadioGroup1.ItemIndex = 0) then tolerance:= 2*tolerance;

  efface_stringgrid3;
  efface_stringgrid8;
  efface_stringGrid6;
  nb_raies_obs:=0;

  //AssignFile(nomf,'espion');
  //rewrite(nomf);
  //for j:=1 to nb_raies_dif do writeln(nomf,j:5,theta_dif[j]:10:3);
  //writeln(nomf,'INDX');
  //for j:=1 to nb_raies_indx do writeln(nomf,j:5,dtheta_indx[j]:10:3);
  nb_raies_i20:=0;
  for j:=1 to nb_raies_dif do begin
    {recherche de la raie calcule la + proche dans le spectre IND}
    dist_min:=1000;
    if (theta_dif[j] < theta_min) or (theta_dif[j] > theta_max) then continue;
    i_raie:=1;
    for k:=1 to nb_raies_indx do begin
      if (raies_indx[k].ext = 1)then continue;
      dist:=abs(theta_dif[j]-raies_indx[k].dtheta);
      if (dist < dist_min)then begin
        ang_calc:=raies_indx[k].dtheta;
        ang_obs:=theta_dif[j];
        dist_min:=dist;
        i_raie:=k;
      end;
    end;
    //writeln(nomf,j:5,i_raie:5,ang_calc:10:3,ang_obs:10:3,dist_min:10:4);
    if (dist_min > tolerance)then continue;
    {Mise en tableau de la raie slecte}
    nb_raies_obs:=nb_raies_obs+1;

//Calcul de I/I20 24/11/00
    if (j <= 20)then nb_raies_i20:=nb_raies_i20+1;

    if (nb_raies_obs >= 1000)then begin
      erreur('Too many reflections (> 1000)');
      nb_raies_obs:=nb_raies_obs-1;
      goto 1;
    end;
    with raies_indx[i_raie] do begin
      h_obs[nb_raies_obs]:=hr;
      k_obs[nb_raies_obs]:=kr;
      l_obs[nb_raies_obs]:=lr;
    end;
    dtheta_obs[nb_raies_obs]:=ang_obs;
    dtheta_calc[nb_raies_obs]:=ang_calc;
    numero4:=j;
  end;
1:  ordre_raies_obs;
  //closefile(nomf);
  ecrit_stringgrid3;
//-----------------------------------------------------------------------------
  dessin;
end;

//=========================Fichiers Profil=====================================
procedure lecture_fichier_raw(num: integer);
//-----------------------------------------
var
  s,s1                                     :string;
  i,numero_anode                           : integer;
const
  type_anode : array[1..5] of string[2]= ('Mo','Cu','Co','Fe','Cr');
  wl1 : array[1..5]of real = (0.70930,1.54056,1.78897,1.93339,2.28970);
  wl2 : array[1..5]of real = (0.71359,1.54439,1.79285,1.93730,2.29361);
  wl  : array[1..5]of real = (0.71070,1.54180,1.79020,1.93604,2.29090);
begin
  couleur_raw:= clfuchsia;
  form1.OpenDialog3.FilterIndex:=num;
  if form1.OpenDialog3.execute then begin
      nom_fichier_raw:=form1.OpenDialog3.filename;
      if(length(nom_fichier_raw) > 0)then begin
        if (pos('.rd',nom_fichier_raw) > 0) then num:=4;
        if (pos('.raw',nom_fichier_raw) > 0)then num:=1;
        if (pos('.dat',nom_fichier_raw) > 0)then num:=2;
        if (pos('.cpi',nom_fichier_raw) > 0)then num:=3;
      end else exit;
 end else exit;
 if (nb_raies_dif = 0) then begin
    lambda:=0;
    theta_min:=0;
    theta_min_depart:=0;
    theta_max:=0;
    theta_max_depart:=0;
 end;
 case num of
    1: liraw_brucker;
    2: liraw_rietveld;
    3: liraw_cpi;
    4: liraw_philips;
  end;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  if (lambda_raw = 0)then begin
    dif_raw:=2;
    flilambda.visible:=true;
    exit;
  end;

    //wl1 et/ou wl2 n'ont pas t lus
    if (lambda1_raw = 0) or (lambda2_raw = 0) and (anode_raw <> '')then begin
      s1:=anode_raw;s1:=uppercase(s1);
      for i:=1 to 5 do begin
        s:=type_anode[i];s:=uppercase(s);
        if (s = s1)then begin
          lambda1_raw:=wl1[i];
          lambda2_raw:=wl2[i];
          if (ratio_raw = 0)then ratio_raw:=0.50;
          break;
        end;
      end;
    end;

    //wl n'a pas t lu
    if (lambda_raw = 0) and (lambda1_raw > 0) then
    lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw);

    //La nature de l'anode n'a pas t lue
    anode_raw:=trim(anode_raw);
    if (anode_raw ='') or (anode_raw = '?')then begin
      numero_anode:=0;
      if (lambda_raw > 0)then begin
        for i:=1 to 5 do begin
          if (abs(lambda_raw-wl[i]) < 0.01)then begin
            numero_anode:=i;
            break;
          end;
        end;
      end;
      if (numero_anode > 0)then
      anode_raw:=type_anode[numero_anode] else anode_raw:='?';
    end;

    if (ratio_raw = 0) and (anode_raw <> '')then ratio_raw:=0.5;

    //La L.O. est-elle diffrente de la L.O. courante?
    if (lambda_dif = 0)then begin
      lambda:=lambda_raw;
      lambda1:=lambda1_raw;
      lambda2:=lambda2_raw;
      ratio:=ratio_raw;
      theta_min:=theta_min_raw;
      theta_max:=theta_max_raw;
      theta_min_depart:=theta_min_raw;
      theta_max_depart:=theta_max_raw;
      ecrit_paneau19;
    end else begin
      if (abs(lambda_raw-lambda_dif) > 0.01)then begin
        erreur('The wavelength read in the file is different from'+
        ' the wavelength of the measured peaks');
        exit;
      end;
    end;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //Apparition du paneau 21
  ecrit_paneau21;
  dessin;
end;

procedure Tform6.lit_fichier_brucker(Sender: TObject);
//------------------------------------------------
begin
  lecture_fichier_raw(1);
end;

procedure Tform6.lit_fichier_rietfeld(Sender: TObject);
//-----------------------------------------------------
begin
  lecture_fichier_raw(2);
end;

procedure Tform6.lit_fichier_cpi(Sender: TObject);
//-----------------------------------------------
begin
  lecture_fichier_raw(3);
end;

procedure Tform6.lit_fichier_philips(Sender: TObject);
//----------------------------------------------------
begin
  lecture_fichier_raw(4);
end;
//============================================================================

procedure Tform6.undisplay_edit8(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
//----------------------------------------------------------------------
begin
    edit4.text:='';
end;

procedure Tform6.echelle_modi(Sender: TObject; var AllowChange: Boolean);
//-----------------------------------------------------------------------
begin
  if (UpDown2.position = UpDown2.max) then exit;
  facteur_echelle:=UpDown2.position/10;
  dessin;
  image1.refresh;
end;

procedure Tform6.shifte_diagramme(Sender: TObject;
  var AllowChange: Boolean);
//-----------------------------------------------
var
  position_lue             : integer;
  X                        : real;
begin
  position_lue:=UpDown1.position;
  x:=position_lue-pos0;
  theta_min:=theta_min+x;
  theta_max:=theta_max+x;
  pos0:=position_lue;
  dessin;
  image1.refresh;
end;

procedure Tform6.init_active(Sender: TObject);
//-------------------------------------------
begin
  souris_down:=false;
end;

procedure Tform6.reset_dessin(Sender: TObject);
//--------------------------------------------
begin
  souris_down:=false;
  theta_min:=theta_min_depart;
  theta_max:=theta_max_depart;
  theta_min_av:=theta_min_depart;
  theta_max_av:=theta_max_depart;
  ecrit_paneau19;
  etendue:=theta_max-theta_min;
  facteur_echelle:=1;
  updown2.position:=10;
  dessin;
end;

procedure efface_stringGrid3;
//---------------------------
var
  i,j  : integer;
begin
  with form1.stringGrid3 do begin
      for I := 0 to ColCount - 1 do
      for J:= 1 to RowCount - 1 do Cells[I,J] := '';
  end;
end;

procedure Tform6.raze_selection(Sender: TObject);
//----------------------------------------------
begin
  efface_stringgrid3;
  efface_stringgrid8;
  efface_stringGrid6;
  nb_raies_obs:=0;
  dessin;
 end;

procedure Tform6.change_theta_2theta(Sender: TObject);
//----------------------------------------------------
begin
  form1.RadioGroup1.ItemIndex:=RadioGroup1.ItemIndex;
  form1.change_angles(sender);
end;

procedure Tform6.efface_diagramme_raw(Sender: TObject);
//-----------------------------------------------------
begin
  nom_fichier_raw:='';
  dessin;
end;

procedure Tform6.charge_spectre(Sender: TObject);
//-----------------------------------------------
begin
  form6.PopupMenu2.popup(form6.left+150,form6.top+200);
end;

//Evnement OnMouseMove : Affichage des coordonnes du rticule sur le spectre
procedure Tform6.affiche_theta(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
//--------------------------------------------------------------------
var
  xcm,ycm,d                                 : real;
  s,s1                                      : string;
begin

  //affichage de l'angle theta ou 2Theta
  if(echx=0)then exit;
  pxtocm(x,y,xcm,ycm);
  str(xcm:8:2,s1);
  if(RadioGroup1.itemIndex = 0)then s:='T=' else s:='2T=';
  s:=s+s1;
  if(form1.radiogroup1.itemIndex = 0)then d:=lambda_raw/(2*sin(xcm/57.2957))
  else  d:=lambda/(2*sin(xcm/114.592));
  str(d:7:3,s1);
  s:=s+'  d='+s1;
  edit4.text:=s;

  //Trac du carr "Zoom"
  if souris_down then begin
    flag_zoom:=true;
    image1.picture.assign(clipboard);
    with image1.canvas do begin
       pen.color:=clgray;
       moveto(x,y);
       lineto(x_av,y);
       lineto(x_av,y_av);
       lineto(x,y_av);
       lineto(x,y);
       pen.color:=clblack;
    end;
  end;
end;

//==============================Evnements image1===============================
//Evnement OnMouseUp
procedure Tform6.MouseUp_image1(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//----------------------------------------------------------------------
var
  xcm,ycm,dist_ret,ang_calc,ang2_calc,ang_obs,ang2_obs   : real;
  dist,dist_min                                          : real;
  i,j,k,xx,yy,nn,ix,iy ,i_raie,ier                       : integer;
  s,s1,s2,s3                                             : string;
begin
 if (y < 0)then exit;
 x_up:=x;
 y_up:=y;
 souris_down:=false;

 //Sortie de Zoom
 if (abs(x-x_av) > 4)  then begin
    theta_min_av:=theta_min;theta_max_av:=theta_max;
    pxtocm(x_av,y_av,theta_min,ycm);
    pxtocm(x,y,theta_max,ycm);
    if (theta_min > theta_max)then begin
       dist:=theta_min;
       theta_min:=theta_max;
       theta_max:=dist;
    end;
    if (RadioGroup1.ItemIndex = 0)then begin
      theta_min:=theta_min*2;
      theta_max:=theta_max*2;
    end;
    ecrit_paneau19;
    if (y_av < y) then dist:=image1.height-y_zero-y_av else
    dist:=image1.height-y_zero-y;
    if (dist < 2)then dist:=2;
    facteur_echelle:=facteur_echelle*(image1.height-y_zero)/dist;
    updown2.position:=round(10*facteur_echelle);
    dessin;
    exit;
 end;

 //dessin;
 if (nb_raies_dif = 0) or (nb_raies_indx = 0)then exit;

//Effacement d'une raie=========================================================
 if (form1.PageControl1.activepage = form1.TabSheet3) and (button = mbright)
 then begin
    nn:=0;
    for i:=1 to nb_raies_obs do begin
      if(RadioGroup1.itemindex = 0)then cmtopx(0.5*dtheta_obs[i],0,ix,iy);
      if(RadioGroup1.itemindex = 1)then cmtopx(dtheta_obs[i],0,ix,iy);
      if (abs(x-ix) < 4) then begin
        nn:=i;
        break;
      end;
    end;
    if(nn = 0)then exit;

    if (nn = nb_raies_obs)then begin
      nb_raies_obs:=nb_raies_obs-1;
      if(nb_raies_obs < 15)then begin
        form1.stringgrid3.rowcount:=25;
      end else begin
        form1.stringgrid3.rowcount:=nb_raies_obs+2;
      end;
    end else begin
      for i:=nn to nb_raies_obs-1 do begin
        dtheta_obs[i]:=dtheta_obs[i+1];
        dtheta_calc[i]:=dtheta_calc[i+1];
        h_obs[i]:=h_obs[i+1];
        k_obs[i]:=k_obs[i+1];
        l_obs[i]:=l_obs[i+1];
      end;
      nb_raies_obs:=nb_raies_obs-1;
    end;
    if(nb_raies_obs < 25)then begin
      form1.stringgrid3.rowcount:=25;
    end else begin
      form1.stringgrid3.rowcount:=nb_raies_obs+2;
    end;
    ecrit_stringgrid3;
    efface_stringgrid6;
    //form1.PageControl1.activepage:=form1.TabSheet3;
    dessin;
    exit;
 end;

//Click sur une nouvelle raie===================================================
if (form1.PageControl1.activepage = form1.TabSheet3)and (button = mbleft)
then begin
  image1.canvas.font.color:=clblack;
  s:=form1.edit26.text;
  val(s,tolerance,ier);
  if (ier > 0)then begin
    erreur('Error (angular tolerance)');
    exit;
  end;
  if (RadioGroup1.ItemIndex = 0) then tolerance:= 2*tolerance;

//Calcul
{On a cliqu sur la partie calcule du spectre}
  if (y > image1.height-y_zero) then begin

    for j:=1 to nb_raies_indx do begin

{recherche de la raie calcule clique dans le spectre IND}
      xcm:=raies_indx[j].dtheta;
      if(RadioGroup1.ItemIndex = 0)then xcm:=0.5*xcm;
      cmtopx(xcm,0,ix,iy);
      if(abs(x-ix) < 4)then begin
        ang2_calc:=raies_indx[j].dtheta;

        ang_calc:=0.5*ang2_calc/57.2957;

{recherche de la raie observe la + proche dans le spectre DIF}
        ang2_obs:=0;
        dist_min:=1000;
        if (nb_raies_dif > 0)then begin
          for k:=1 to nb_raies_dif do begin
            dist:=abs(ang2_calc-theta_dif[k]);
            if (dist < dist_min)then begin
              ang2_obs:=theta_dif[k];
              dist_min:=dist;
              i_raie:=k;
            end;
          end;
        end;
        if (dist_min > tolerance) then continue;

 {Cette raie a-t-elle dj t slectionne?}
        ier:=0;
        for i:=1 to nb_raies_obs do begin
           if (raies_indx[j].hr = h_obs[i]) and (raies_indx[j].kr = k_obs[i])and
           (raies_indx[j].lr = l_obs[i]) then begin
             ier:=1;
             break;
           end;
        end;
        if (ier = 1)then continue;

 {Mise en tableau de la raie slecte}
        nb_raies_obs:=nb_raies_obs+1;
        with raies_indx[j] do begin
          h_obs[nb_raies_obs]:=hr;
          k_obs[nb_raies_obs]:=kr;
          l_obs[nb_raies_obs]:=lr;
        end;
        dtheta_obs[nb_raies_obs]:=ang2_obs;
        dtheta_calc[nb_raies_obs]:=ang2_calc;
        {music;}
         numero5:=j;
         break;
      end;
    end;
    if(nb_raies_obs < 15)then begin
      form1.StringGrid3.rowcount:=25;
    end else begin
      form1.StringGrid3.rowcount:=nb_raies_obs+2;
    end;
    efface_stringgrid6;
    ecrit_stringgrid5;
    numero4:=i_raie;
    ecrit_stringgrid4;
  end;
//Observ
  {On a cliqu sur la partie observe du spectre}
  if (y < image1.height-y_zero) then begin

    for j:=1 to nb_raies_dif do begin
      {recherche de la raie observe clique dans le spectre DIF}
      xcm:= theta_dif[j];
      if (RadioGroup1.ItemIndex = 0)then xcm:=0.5*xcm;
      cmtopx(xcm,0,ix,iy);
      if(abs(x-ix) < 4)then begin
        ang2_obs:=theta_dif[j];
        ang_obs:=0.5*ang2_obs/57.2957;
        dist_min:=1000;
        i_raie:=1;
        if (nb_raies_indx > 0)then begin
          for k:=1 to nb_raies_indx do begin
            dist:=abs(ang2_obs-raies_indx[k].dtheta);
            if (dist < dist_min)then begin
              ang2_calc:=raies_indx[k].dtheta;
              dist_min:=dist;
              i_raie:=k;
            end;
          end;
        end;
        if (dist_min > tolerance) then continue;

        {Cette raie a-t-elle dj t slectionne?}
        ier:=0;
        for i:=1 to nb_raies_obs do begin
           if (raies_indx[i_raie].hr = h_obs[i]) and
              (raies_indx[i_raie].kr = k_obs[i]) and
              (raies_indx[i_raie].lr = l_obs[i]) then begin
             ier:=1;
             break;
           end;
        end;
        if (ier = 1)then continue;

       {Mise en tableau de la raie slecte}
        nb_raies_obs:=nb_raies_obs+1;
        with raies_indx[i_raie] do begin
          h_obs[nb_raies_obs]:=hr;
          k_obs[nb_raies_obs]:=kr;
          l_obs[nb_raies_obs]:=lr;
        end;
        dtheta_obs[nb_raies_obs]:=ang2_obs;
        dtheta_calc[nb_raies_obs]:=ang2_calc;
        numero4:=j;
        break;
      end;
      if(nb_raies_obs < 15)then begin
        form1.StringGrid3.rowcount:=25;
      end else begin
        form1.StringGrid3.rowcount:=nb_raies_obs+2;
      end;
    end;
    ecrit_StringGrid4;
    numero5:=i_raie;
    ecrit_stringgrid5;
    efface_stringgrid6;
  end;
  ordre_raies_obs;
  ecrit_stringgrid3;
  dessin;
end;
end;

//Evnement OnMouseDown
procedure Tform6.souris_onmouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//-----------------------------------------------------------------------
begin
  x_down:=x;
  y_down:=y;
  souris_down:=true;
  x_av:=x;
  y_av:=y;
  clipboard.Assign(image1.picture);
end;                                                                                                                                                                                                                                                                                                                                                                                                                

procedure Tform6.imprime_ecran(Sender: TObject);
//----------------------------------------------
begin
  Printer.Orientation:=PoLandscape;
  print;
end;

(*procedure indx_eteint;{
---------------------}
var
  h_groupe,k_groupe,l_groupe                           : integer;
  i,j,h,k,l,h1,h2,k1,k2,l1,l2,ier                      : integer;
  hh,kk,ll,hmax,kmax,lmax                              : integer;
  x,y,z,r2hkl,lbds2,dhkl                               : real;
  r2hkl_min,r2hkl_max,sithl                            : real;
  nr                                                   : integer;
  resultat                                             : array[1..10000] of ^raie;
  buf                                                  : raie;
  xlp,theta_rad,echel                                  : real;
  nomf                                                 : textfile;
label 1;
begin
  assignfile(nomf,'forbidden.txt');
  rewrite(nomf);

  screen.cursor:=crhourglass;
  bravais:=copy(groupe_espace,1,1);
  if(systeme = 'RHOM')then bravais:='P';

  // limites des boucles
  x:=2*sin(theta_max_depart/(57.2957*2))/lambda;
  hmax:=round(x/celr[1])+1;
  kmax:=round(x/celr[2])+1;
  lmax:=round(x/celr[3])+1;
  h1:=-hmax;
  h2:=hmax;
  k1:=-kmax;
  k2:=kmax;
  l1:=0;
  l2:=lmax;

  nb_raies_indx_eteint_eteint:=0;
  lbds2:=lambda/2;
  r2hkl_min:=2*sin(theta_min_depart/114.5914)/lambda;
  r2hkl_min:=(r2hkl_min*r2hkl_min);
  r2hkl_max:=2*sin(theta_max_depart/114.5914)/lambda;
  r2hkl_max:=(r2hkl_max*r2hkl_max);

  nb_raies_indx_eteint_eteint:=0;
  nr:=0;
  if (bravais = 'N')then bravais:='P';
  for h:=h2 downto h1 do begin
    for k:=k2 downto k1 do begin
      for l:=l1 to l2 do begin

        extinc(h,k,l,ier);
        if (ier = 0)then continue;

//Calcul de theta,dhkl
        x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
        y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
        z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
        r2hkl:=x*x+y*y+z*z;
        if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
        dhkl:=1/sqrt(r2hkl);

//Mise en tableau de la raie dans le record
        nb_raies_indx_eteint_eteint:=nb_raies_indx_eteint_eteint+1;
        if (nb_raies_indx_eteint_eteint >= 9999)then begin
          for i:=1 to nb_raies_indx_eteint_eteint-1 do dispose(resultat[i]);
          erreur('Too many calculated reflections. Decrease the theta range');
          nb_raies_indx_eteint_eteint:=0;
          screen.cursor:=crdefault;
          closefile(nomf);
          exit;
        end;
        new(resultat[nb_raies_indx_eteint_eteint]);
        with resultat[nb_raies_indx_eteint_eteint]^ do begin
          hr:=h;
          kr:=k;
          lr:=l;
          dr:=dhkl;
          //dtheta:=114.5914*arcsin(lambda/(2*dr));
        end;
      end;
    end;
  end;

  //Mise en ordre
  for i:=1 to nb_raies_indx_eteint_eteint-1 do begin
    for j:=i+1 to nb_raies_indx_eteint_eteint do begin
      if (resultat[i]^.dr < resultat[j]^.dr) then begin
        buf:=resultat[j]^;
        resultat[j]^:=resultat[i]^;
        resultat[i]^:=buf;
      end;
    end;
  end;

  //Regroupement des raies de mme dhkl
  nr:=0;
  for i:=1 to nb_raies_indx_eteint_eteint do begin
    if (resultat[i]^.dr = 0) then continue; //Cette raie a dja t intgre dans un groupe
    nr:=nr+1;
    if (nr >= 1000)then begin
      erreur('Too many calculated reflections (>1000)');
      nr:=nr-1;
      goto 1
    end;
    with resultat[i]^ do begin
       h_groupe:=hr;
       k_groupe:=kr;
       l_groupe:=lr;
    end;
    if (i < nb_raies_indx_eteint_eteint) then begin
      for j:=i+1 to nb_raies_indx_eteint_eteint do begin
        if(resultat[j]^.dr = 0)then continue;     //La raie n'existe plus
        if (abs(resultat[j]^.dr - resultat[i]^.dr) > 0.0001)then break;
        if (resultat[j]^.hr >= 0) and  (resultat[j]^.kr >= 0)
        and (resultat[j]^.lr >= 0) then begin     //On choisit les indices positifs
          h_groupe:=resultat[j]^.hr;
          k_groupe:=resultat[j]^.kr;
          l_groupe:=resultat[j]^.lr;
        end;
        resultat[j]^.dr:=0;
     end;
    end;
//???????????????????????????????????????????????????????????????????????????
    with raies_indx_eteint_eteint[nr] do begin
      hr:=h_groupe;
      kr:=k_groupe;
      lr:=l_groupe;
      dr:=resultat[i]^.dr;
      ext:=1;
      dtheta:=114.5914*arcsin(lambda/(2*dr));
      writeln(nomf,hr:4,kr:4,lr:4,dr:10:4,dtheta:10:3);
    end;
//????????????????????????????????????????????????????????????????????????????

    //dispose(resultat[i]);
  end;
  1: for i:=1 to nb_raies_indx_eteint_eteint do  dispose(resultat[i]);
  nb_raies_indx_eteint_eteint:=nr;
  closefile(nomf);
  screen.cursor:=crdefault;
end;
     *)

procedure indx_eteint;{
----------------------}
var
  h_groupe,k_groupe,l_groupe                           : integer;
  i,j,h,k,l,h1,h2,k1,k2,l1,l2,ier                      : integer;
  hh,kk,ll,hmax,kmax,lmax                              : integer;
  x,y,z,r2hkl,lbds2,dhkl                               : real;
  r2hkl_min,r2hkl_max,sithl                            : real;
  nr                                                   : integer;
  result                                               : array[1..10000] of ^raie;
  buf                                                  : raie;
  xlp,theta_rad,echel                                  : real;
  r1,r2,r3                                             : real;
  nomf  : textfile;
label 1;
begin
  //form6.speedbutton2.down:=true;
  bravais:=copy(groupe_espace,1,1);
  if(systeme = 'RHOM')then bravais:='P';

  decode_conditions(ier);
  if (ier = 1)then exit;

//limites des boucles
  setmat;
  x:=2*sin(theta_max_depart/(57.2957*2))/lambda;

//Modif du 29 octobre 2001 (Eugene Cheung)
  r1:=x/sin(celr[6]/57.2957);
  r2:=x/sin(celr[4]/57.2957);
  r3:=x/sin(celr[5]/57.2957);
  if (r1 > r3)then hmax:=round(r1/celr[1])+1 else hmax:=round(r3/celr[1])+1;
  if (r1 > r2)then kmax:=round(r1/celr[2])+1 else kmax:=round(r2/celr[2])+1;
  if (r2 > r3)then lmax:=round(r2/celr[3])+1 else lmax:=round(r3/celr[3])+1;

  h1:=-hmax;
  h2:=hmax;
  k1:=-kmax;
  k2:=kmax;
  l1:=0;
  l2:=lmax;

  lbds2:=lambda/2;
  r2hkl_min:=2*sin(theta_min_depart/114.5914)/lambda;
  r2hkl_min:=(r2hkl_min*r2hkl_min);
  r2hkl_max:=2*sin(theta_max_depart/114.5914)/lambda;
  r2hkl_max:=(r2hkl_max*r2hkl_max);

  nb_raies_indx_eteint:=0;
  nb_somme:=0;

  nb_raies_indx_eteint:=0;
  if (systeme = 'CUBI')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=k to l2 do begin
          extinc(h,k,l,ier);
          if (ier = 0)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);

          nb_raies_indx_eteint:=nb_raies_indx_eteint+1;
          if (nb_raies_indx_eteint >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx_eteint do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx_eteint]);
          with result[nb_raies_indx_eteint]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'TETR')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          extinc(h,k,l,ier);
          if (ier = 0)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx_eteint:=nb_raies_indx_eteint+1;
          if (nb_raies_indx_eteint >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx_eteint do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx_eteint]);
          with result[nb_raies_indx_eteint]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'ORTH')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          extinc(h,k,l,ier);
          if (ier = 0)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx_eteint:=nb_raies_indx_eteint+1;
          if (nb_raies_indx_eteint >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx_eteint do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx_eteint]);
          with result[nb_raies_indx_eteint]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'HEXA')then begin
    for h:=0 to h2 do begin
      for k:=h to k2 do begin
        for l:=0 to l2 do begin
          extinc(h,k,l,ier);
          if (ier = 0)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx_eteint:=nb_raies_indx_eteint+1;
          if (nb_raies_indx_eteint >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx_eteint do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx_eteint]);
          with result[nb_raies_indx_eteint]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'RHOM')then begin
    for h:=0 to h2 do begin
      for k:=h to h2 do begin
        if (h = 0) and (k = 0)then continue;
        for l:=-h2 to h2 do begin
          extinc(h,k,l,ier);
          if (ier = 0)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx_eteint:=nb_raies_indx_eteint+1;
          if (nb_raies_indx_eteint >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx_eteint do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx_eteint]);
          with result[nb_raies_indx_eteint]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'MONO')then begin
    for h:=-h2 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          extinc(h,k,l,ier);
          if (ier = 0)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx_eteint:=nb_raies_indx_eteint+1;
          if (nb_raies_indx_eteint >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx_eteint do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx_eteint]);
          with result[nb_raies_indx_eteint]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'TRIC')then begin
    for h:=-h2 to h2 do begin
      for k:=-k2 to k2 do begin
        for l:=0 to l2 do begin
          extinc(h,k,l,ier);
          if (ier = 0)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx_eteint:=nb_raies_indx_eteint+1;
          if (nb_raies_indx_eteint >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx_eteint do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx_eteint]);
          with result[nb_raies_indx_eteint]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

//Mise en ordre
  for i:=1 to nb_raies_indx_eteint-1 do begin
    for j:=i+1 to nb_raies_indx_eteint do begin
      if (result[i]^.dr < result[j]^.dr) then begin
        buf:=result[j]^;
        result[j]^:=result[i]^;
        result[i]^:=buf;
      end;
    end;
  end;

//Ecriture
  (*assignfile(nomf,'mouchard.txt');
  rewrite(nomf);
  for i:=1 to nb_raies_indx_eteint do begin
    with result[i]^ do begin
      writeln(nomf,i:5,hr:3,kr:3,lr:3,dr:8:4);
    end;
  end; *)

//Regroupement des raies de mme dhkl
  nr:=0;
  for i:=1 to nb_raies_indx_eteint do begin
    if (result[i]^.dr = 0) then continue; //Cette raie a dja t intgre dans un groupe
    nr:=nr+1;
    if (nr >= 10000)then begin
      erreur('Too many calculated reflections (>10000)');
      nr:=nr-1;
      goto 1
    end;
    with result[i]^ do begin
       h_groupe:=hr;
       k_groupe:=kr;
       l_groupe:=lr;
    end;
    if (i < nb_raies_indx_eteint) then begin
      for j:=i+1 to nb_raies_indx_eteint do begin
        if(result[j]^.dr = 0)then continue;     //La raie n'existe plus
        if (abs(result[j]^.dr - result[i]^.dr) > 0.0001)then break;
        if (result[j]^.hr >= 0) and  (result[j]^.kr >= 0)
        and (result[j]^.lr >= 0) then begin     //On choisit les indices positifs
          h_groupe:=result[j]^.hr;
          k_groupe:=result[j]^.kr;
          l_groupe:=result[j]^.lr;
        end;
        result[j]^.dr:=0;
     end;
    end;
//???????????????????????????????????????????????????????????????????????????
    with raies_indx_eteint[nr] do begin
      hr:=h_groupe;
      kr:=k_groupe;
      lr:=l_groupe;
      dr:=result[i]^.dr;
      ext:=0;
      dtheta:=114.5914*arcsin(lambda/(2*dr));
    end;
//????????????????????????????????????????????????????????????????????????????

    //dispose(result[i]);
  end;
  1: for i:=1 to nb_raies_indx_eteint do  dispose(result[i]);
  nb_raies_indx_eteint:=nr;

 (* writeln(nomf);
  writeln(nomf,'Apres tri:');
    for i:=1 to nb_raies_indx_eteint do begin
    with raies_indx_eteint[i] do begin
      writeln(nomf,i:5,hr:3,kr:3,lr:3,dr:8:4);
    end;
  end;
  closefile(nomf);  *)
end;


procedure Tform6.change_extinc(Sender: TObject);
//----------------------------------------------
begin
  if (nb_raies_indx = 0)then begin
    speedbutton2.down:=true;
    exit;
  end;
  if (speedbutton2.down = false)then begin
    indx_eteint;
  end else nb_raies_indx_eteint:=0;
  ecrit_stringgrid1;
  dessin;
end;


end.
