//Recherche du meilleur groupe
unit best_space;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  Tfbest_space = class(TForm)
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    Label3: TLabel;
    Edit3: TEdit;
    BitBtn3: TBitBtn;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Memo2: TMemo;
    BitBtn1: TBitBtn;
    procedure sortie(Sender: TObject);
    procedure ecrit(Sender: TObject);
    procedure init_fbest_space(Sender: TObject);
    procedure print_edit(Sender: TObject);
    procedure modif_tolerance(Sender: TObject);
    procedure lit_tolerance(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fbest_space: Tfbest_space;

implementation

uses
   mathhkl,unit3,unit3b,unit1,unit4,unit5,unit6, best_sol, supple;

var
  nb_lignes                : integer;

{$R *.DFM}

var
    nb_indx_crsf    : integer;
    
procedure Tfbest_space.sortie(Sender: TObject);
//----------------------------------------
begin
  close;
end;

procedure Tfbest_space.ecrit(Sender: TObject);
//--------------------------------------
var
  s,s1                                                   : string;
  s8                                                     : string[8];
  n,no,k,i_raie,ier,i,j,i_groupe,
  nb_raies_ind_max,nb_raies_calc_min,nb_raies_calc,
  item_old,h,l                                           : integer;
  maille                                                 : tab_reel;
  ang_calc,ang_obs                                       : real;
  dist,dist_min                                          : real;
  count_raies_calc,count_raies_ind                       : array[1..1000] of integer;
  sigma                                                  : array[1..1000] of double;
  groupe                                                 : array[1..100] of string[8];
  spgr                                                   : array[1..1000] of string[8];
  nomf                                                   : TextFile;

  r                                         : array[1..3,1..3] of integer;
  Oabc                                      : array[1..6,1..3,1..3] of integer;
  Mabc                                      : array[1..3,1..3,1..3] of integer;
  i_setting,nb_setting,no_test,indexe_min   : integer;
  const
   Osetting  : array[1..6] of string[4]= ('abc','cab','bca','a-cb','ba-c','-cba');

  label  1;
begin
for i:=1 to 3 do begin
  for j:=1 to 3 do begin
    Oabc[1,i,j]:=0;
    Oabc[2,i,j]:=0;
    Oabc[3,i,j]:=0;
    Oabc[4,i,j]:=0;
    Oabc[5,i,j]:=0;
    Oabc[6,i,j]:=0;
    Mabc[1,i,j]:=0;
    Mabc[2,i,j]:=0;
    Mabc[2,i,j]:=0;
  end;
end;
Oabc[1,1,1]:=1;Oabc[1,2,2]:=1;Oabc[1,3,3]:=1;
Oabc[2,1,3]:=1;Oabc[2,2,1]:=1;Oabc[2,3,2]:=1;
Oabc[3,1,2]:=1;Oabc[3,2,3]:=1;Oabc[3,3,1]:=1;
Oabc[4,1,1]:=1;Oabc[4,2,3]:=-1;Oabc[4,3,2]:=1;
Oabc[5,1,2]:=1;Oabc[5,2,1]:=1;Oabc[5,3,3]:=-1;
Oabc[6,1,3]:=-1;Oabc[6,2,2]:=1;Oabc[6,3,1]:=1;

with fbest_space do begin

  memo1.clear;
  memo1.Refresh;
  nb_lignes:=0;
  if (systeme = 'ORTHO') then
  memo1.Lines.add('Sp. Group    Sigma       Indexed  Calculat.  Setting ')
  else
  memo1.Lines.add('Sp. Group    Sigma       Indexed  Calculated ');

  nb_lignes:=nb_lignes+1;

  if (nb_raies_dif = 0) then begin
    erreur('No measures lines');
    exit;
  end;

  if (nb_raies_indx = 0) then begin
    erreur('No calculated reflections');
    exit;
  end;
  val(edit3.text,tolerance,ier);
  val(edit1.text,indexe_min,ier);
  val(trim(edit2.text),nb_indx_crsf,ier);
  form1.edit26.text:=edit3.text;
  form1.edit37.text:=edit3.text;

  nb_raies_ind_max:=0;
  nb_raies_calc_min:=10000;
  no_test:=0;
 (* if(form1.panel12.visible = true) then begin
    s:=copy(form1.listbox4.items[form1.listbox4.itemindex],5,3);
    nb_indx_crsf:=strtoint(s);  //Nb de raies indexes par Crysfire
  end; *)

  (*assignfile(nomf,'espion.txt');
  rewrite(nomf);*)

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//Boucle sur les groupes d'espace
  for i_groupe:=1 to nb_groupes do begin
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    form1.listbox2.itemIndex:=i_groupe-1;
    s:=form1.listbox2.items[i_groupe-1];
    if(s = '')then break;

//Selection du groupe
    groupe_espace:=uppercase(s);
    bravais:=copy(groupe_espace,1,1);
    if(systeme = 'RHOM')then bravais:='P';
    if (bravais = 'N')then bravais:='P'; //No. Ext
    decode_conditions(ier);
    if (ier > 0)then begin
      erreur('Conditions decoding error');
      exit;
    end;

//*****************************************************************************
    Nb_setting:=1;
    if (systeme = 'ORTH') and  (nb_ligne_code > 0) then nb_setting:=6;
    for i_setting:=1 to nb_setting do begin
      for i:=1 to 3 do
      for j:=1 to 3 do r[i,j]:=Oabc[i_setting,i,j];
//*****************************************************************************
     (* nb_raies_calc:=0;
      for j:=1 to nb_raies_indx do begin
        with raies_indx[j] do begin
          h:=r[1,1]*hr+r[1,2]*kr+r[1,3]*lr;
          k:=r[2,1]*hr+r[2,2]*kr+r[2,3]*lr;
          l:=r[3,1]*hr+r[3,2]*kr+r[3,3]*lr;
          extinc(h,k,l,ier);
          ext:=ier;
          if (ier = 0)then nb_raies_calc:=nb_raies_calc+1;
        end;
      end; *)
      indx;
      nb_raies_calc:=0;
      for i:=1 to nb_raies_indx do
      if(raies_indx[i].ext = 0)then nb_raies_calc:=nb_raies_calc+1;

//recherche des raies calcules(indx) proches des raies dif
      nb_raies_obs:=0;
      for j:=1 to nb_raies_dif do begin
        dist_min:=1000;
        //if (theta_dif[j] < theta_min) or (theta_dif[j] > theta_max) then continue;
        i_raie:=1;
        for k:=1 to nb_raies_indx do begin
          if (raies_indx[k].ext = 1)then continue;
          dist:=(theta_dif[j]-raies_indx[k].dtheta);
          if (dist < -tolerance)then continue;
          dist:=abs(dist);
          if (dist < dist_min)then begin
            ang_calc:=raies_indx[k].dtheta;
            ang_obs:=theta_dif[j];
            dist_min:=dist;
            i_raie:=k;
          end;
        end;
        if (dist_min > tolerance)then continue;
        nb_raies_obs:=nb_raies_obs+1;
        if (nb_raies_obs >= 1000)then begin
           erreur('Too many reflections (> 1000)');
           nb_raies_obs:=nb_raies_obs-1;
           goto 1;
        end;

        h_obs[nb_raies_obs]:=raies_indx[i_raie].hr;
        k_obs[nb_raies_obs]:=raies_indx[i_raie].kr;
        l_obs[nb_raies_obs]:=raies_indx[i_raie].lr;
        dtheta_obs[nb_raies_obs]:=ang_obs;
        dtheta_obs_cor[nb_raies_obs]:=ang_obs;
        dtheta_calc[nb_raies_obs]:=ang_calc;
        numero4:=j;
      end;
     // writeln(nomf,'Groupe: ',groupe_espace:8,nb_raies_indx:8,nb_raies_calc:8,nb_raies_obs:8);
      if (form1.panel12.visible = true) and (i_setting = 1) and (i_groupe = 1) and
      (nb_raies_obs < nb_indx_crsf) then begin
           erreur('The angular tolerance has been set too fine');
           screen.cursor:=crdefault;
           exit;
      end;

//Calcul de sigma
1:    if (nb_raies_obs < indexe_min)then continue;
      no_test:=no_test+1;
      sigma[no_test]:=0;
      count_raies_ind[no_test]:=0;
      n:=0;
      for i:=1 to nb_raies_dif do begin
        ang_obs:=theta_dif[i];
        k:=0;
        for j:=1 to nb_raies_obs do begin
          if (abs(ang_obs-dtheta_calc[j]) < tolerance)then begin
            k:=j;
            n:=n+1;
            sigma[no_test]:=sigma[no_test]+sqr(ang_obs-dtheta_calc[j]);
            break;
          end;
        end;
      end;
      count_raies_ind[no_test]:=nb_raies_obs;
      count_raies_calc[no_test]:=nb_raies_calc;
      groupe[i_groupe]:=groupe_espace;
      if (nb_raies_ind_max < n)then nb_raies_ind_max:=n;

//Ecriture dans le memo
      s:=form1.listbox2.Items[i_groupe-1];
      if (length(s) < 8)then for k:=length(s) to 8  do s:=s+' ';
      spgr[no_test]:=s;
     // if (i_setting > 1)then s:='         ';
      s:=s+'  ';
      str(sigma[no_test]:8:5,s1);
      s:=s+s1+'  ';
      str(n:8,s1);
      s:=s+s1+'  ';
      str(nb_raies_calc:8,s1);
      s:=s+s1;
      s1:='';
      if (systeme = 'ORTH')then s1:='        '+Osetting[i_setting];
      s:=s+s1;
      memo1.Lines.add(s);
      nb_lignes:=nb_lignes+1;
      efface_stringgrid1;ecrit_StringGrid1;
      ecrit_StringGrid5;
      ecrit_param_depart;
//*****************************************************************************
    end;
//*****************************************************************************
  end;
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//Meilleur groupe
  nb_raies_calc_min:=10000;
  if (no_test = 0)then begin
    memo1.lines.add('No solution. Modify the starting conditions');
    beep;
  end else begin
    for i:=1 to no_test do begin
      if (count_raies_ind[i] = nb_raies_ind_max)then begin
        if (nb_raies_calc_min > count_raies_calc[i])
        then nb_raies_calc_min:=count_raies_calc[i];
      end;
    end;
    memo1.lines.add('Best estimated group(s):');
    nb_lignes:=nb_lignes+1;
    for i:=1 to no_test do begin
      if (count_raies_ind[i] = nb_raies_ind_max)
      and (count_raies_calc[i] = nb_raies_calc_min)then begin
        nb_lignes:=nb_lignes+1;
        s:=memo1.lines[i];
        delete(s,1,8);insert(spgr[i],s,1);
        memo1.lines.add(s);
      end;
    end;
  end;
  efface_stringgrid1;ecrit_StringGrid1;
  ecrit_StringGrid5;
  ecrit_param_depart;
  indx;
  automatic_select;
 end;
end;

procedure Tfbest_space.init_fbest_space(Sender: TObject);
//---------------------------------------------
var
   s           : string;
begin
  memo1.refresh;
  str(tolerance:6:3,s);
  edit3.text:=s;
  //edit2.text:=inttostr(nb_raies_dif);
  if(form1.panel12.visible = true) then begin
    s:=copy(form1.listbox4.items[form1.listbox4.itemindex],5,3);
    nb_indx_crsf:=strtoint(s);  //Nb de raies indexes par Crysfire
  end;
  if(nb_raies_dif < nb_indx_crsf)then begin
    beep;beep;
    showmessage
    ('Warning: The number of observed reflections is lower than the I/I20 given by Crysfire');
    nb_indx_crsf:=nb_raies_dif;
  end;
  edit2.text:=inttostr(nb_indx_crsf);
  edit1.text:=edit2.text;
  if (systeme = 'CUBI')then s:='Cubic system' ;
  if (systeme = 'TETR')then s:='Tetragonal system';
  if (systeme = 'ORTH')then s:='Orthorhombic system';
  if (systeme = 'HEXA')then s:='Trigonal system';
  if (systeme = 'RHOM')then s:='Rhomboedral system';
  if (systeme = 'MONO')then s:='Monoclinic system';
  if (systeme = 'TRIC')then s:='Triclinic system';
  label4.caption:=s;
end;

procedure Tfbest_space.print_edit(Sender: TObject);
//--------------------------------------------
var
    CmdFile      : Pchar;
    iwin,i       : integer;
    nomf         : TextFile;
begin
  assignFile(nomf,'memo1.tmp');
  rewrite(nomf);
  writeln(nomf,extractFilename(nom_fichier_sum));
  for i:=1 to nb_lignes do writeln(nomf,memo1.lines[i-1]);
  CloseFile(nomf);
  CmdFile:='write.exe memo1.tmp';
  iwin:=WinExec(CmdFile,5);
end;

(*procedure Tfbest_space.best_ang_tol(Sender: TObject);
//---------------------------------------------------
var
  tol            : double;
  s              : string;
  w              : word;
begin
   fit_tolerance(tol);
   str(tol:6:3,s);
   w:=messageDlg('The best estimated angular tolerance is '+
   s+'. Do you want to replace the old value?',
   mtConfirmation,mbYesNoCancel,0);
   if (w = mrNo) or (w = mrAbort) then exit;
   edit3.text:=s;
end;  *)

procedure Tfbest_space.modif_tolerance(Sender: TObject);
//------------------------------------------------------
var
  s           : string;
  ier         : integer;
begin
  s:=trim(edit3.text);
  val(s,tolerance,ier);
  if (ier > 0)then begin
    erreur('Read error on tolerance');
    edit3.Focused;
    exit;
  end;
  //s:=trim(edit4.text);

//modification de l'affichage de la tolrance
  fbest_sol.edit4.text:=s;
  fbest_space.edit3.text:=s;
  fsupple.edit4.text:=s;
  form1.Edit37.text:=s;
  form1.Edit26.text:=s;

end;

procedure Tfbest_space.lit_tolerance(Sender: TObject; var Key: Char);
//------------------------------------------------------------------
begin
  if (ord(key) = 13)then modif_tolerance(sender);
end;

end.
