unit bsol_sort;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ComCtrls;

type
  Tfbsol_sort = class(TForm)
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    combobox1: TComboBox;
    ListBox2: TListBox;
    Bevel4: TBevel;
    Bevel2: TBevel;
    Memo2: TMemo;
    BitBtn3: TBitBtn;
    ProgressBar1: TProgressBar;
    procedure init_active(Sender: TObject);
    procedure combo1(Sender: TObject);
    procedure combo2(Sender: TObject);
    procedure abandon(Sender: TObject);
    procedure tri(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fbsol_sort: Tfbsol_sort;
  nb_lignes_sort : integer;

implementation

{$R *.DFM}
uses
  mathhkl, best_sol;

type line = record
  sig                          : real;
  check,calc                   : integer;
  chaine                       : string[130]
end;

var
  ligne                        : array[1..10000] of line;
  titre                        : string;

procedure Tfbsol_sort.init_active(Sender: TObject);
//-------------------------------------------------
var
 s,s1                : string;
 i,j,ier             : integer;
 x                   : real;
 //nomf                : textfile;
begin
  //top:=0;
  //left:=0;
  //assignfile(nomf,'in.txt');
  //rewrite(nomf);
  titre:=listbox2.items[0];
  for i:=1 to nb_lignes_sort do begin
    s:=listbox2.items[i];
    with ligne[i] do begin
      s1:=trim(copy(s,97,9));
      val(s1,x,ier);
      if (ier <> 0)then begin
        erreur('error in sigma');
        exit;
      end;
      sig:=x;
      s1:=trim(copy(s,107,6));
      val(s1,j,ier);
      if (ier <> 0)then begin
        erreur('error in check');
        exit;
      end;
      check:=j;
      s1:=trim(copy(s,114,6));
      val(s1,j,ier);
      if (ier <> 0)then begin
        erreur('error in calc');
        exit;
      end;
      calc:=j;
      s1:=trim(copy(s,1,77));
      if (s1 = '')then begin
        delete(s,1,89);
        s1:=copy(ligne[i-1].chaine,1,89);
        s:=s1+s;
      end;
      chaine:=s;
      //writeln(nomf,s);
    end;
 end;
 //closefile(nomf);
end;

procedure Tfbsol_sort.combo1(Sender: TObject);
//--------------------------------------------
var
  text1          : string;
begin
  refresh;
  text1:=trim(combobox1.text);
  if (text1 = 'Sigma') then begin
     combobox2.clear;
     combobox2.items.add('Checked');
     combobox2.items.add('Calc.');
     combobox2.text:='Checked';
     combobox3.text:='Calc.';
  end;
  if (text1 = 'Checked') then begin
     combobox2.clear;
     combobox2.items.add('Calc.');
     combobox2.items.add('Sigma');
     combobox2.text:='Calc.';
     combobox3.text:='Sigma';
  end;
  if (text1 = 'Calc.') then begin
     combobox2.clear;
     combobox2.items.add('Sigma');
     combobox2.items.add('Checked');
     combobox2.text:='Sigma';
     combobox3.text:='Checked';
  end;
  refresh;
end;

procedure Tfbsol_sort.combo2(Sender: TObject);
//--------------------------------------------
var
  text1,text2,text3       : string;
begin
  text1:=trim(combobox1.text);
  text2:=trim(combobox2.text);
  text3:=trim(combobox3.text);
  combobox3.clear;
  if (text1 = 'Sigma') and (text2 = 'Checked') then begin
    combobox3.items.add('Calc.');
    combobox3.text:='Calc';
  end;
  if (text1 = 'Sigma') and (text2 = 'Calc.') then begin
    combobox3.items.add('Checked');
    combobox3.text:='Checked';
  end;
  if (text1 = 'Checked') and (text2 = 'Sigma')then begin
    combobox3.items.add('Calc.');
    combobox3.text:='Calc.';
  end;
  if (text1 = 'Checked') and (text2 = 'Calc.')   then begin
    combobox3.items.add('Sigma');
    combobox3.text:='Sigma';
  end;
  if (text1 = 'Calc.') and (text2 = 'Checked') then begin
    combobox3.items.add('Sigma');
    combobox3.text:='Sigma';
  end;
  if (text1 = 'Calc.') and (text2 = 'Sigma') then begin
    combobox3.items.add('Checked');
    combobox3.text:='Checked';
  end;
  refresh;
end;

procedure Tfbsol_sort.abandon(Sender: TObject);
//---------------------------------------------
var
 i         : integer;
begin
  fbsol_sort.visible:=false;
end;

procedure Tfbsol_sort.tri(Sender: TObject);
//------------------------------------------
var
  i,j,ier,n           : integer;
  s,s1,s2             : string;
  ligne_dum           : line;
  mode1,mode2,mode3   : integer;
  x1,x2,z1,z2,y1,y2,x : real;
  nb_total,nb         : real;
  //nomf                : textfile;
begin

  //assignfile(nomf,'out.txt');
  //rewrite(nomf);

 if (combobox1.text = 'Sigma')   then mode1:=1;
 if (combobox1.text = 'Checked') then mode1:=2;
 if (combobox1.text = 'Calc.')   then mode1:=3;
 if (combobox2.text = 'Sigma')   then mode2:=1;
 if (combobox2.text = 'Checked') then mode2:=2;
 if (combobox2.text = 'Calc.')   then mode2:=3;
 if (combobox3.text = 'Sigma')   then mode3:=1;
 if (combobox3.text = 'Checked') then mode3:=2;
 if (combobox3.text = 'Calc.')   then mode3:=3;

 if (mode1 = mode2) or (mode2 = mode3) or (mode3 = mode1)then begin
   erreur('Mode selection error');
   exit;
 end;
 screen.cursor:=CRHourGlass;

//Premier tri
   nb:=0;
   progressBar1.visible:=true;
   for i:=1 to nb_lignes_sort-1 do begin
     //label4.caption:='First column';
     nb:=nb+1;
     progressbar1.position:=round(nb*100/(3*nb_lignes_sort-1));
     for j:=i+1 to nb_lignes_sort do begin
        case mode1 of
          1:begin
              x1:=ligne[i].sig;
              x2:=ligne[j].sig
            end;
          2:begin
              x1:=ligne[i].check;
              x2:=ligne[j].check;
           end;
          3:begin
              x1:=ligne[i].calc;
              x2:=ligne[j].calc;
            end;
       end;
       if (radiogroup1.itemIndex = 1)then begin
         if (x2 > x1)then begin
           ligne_dum:=ligne[i];
           ligne[i]:=ligne[j];
           ligne[j]:=ligne_dum;
         end;
       end else begin
         if (x1 > x2)then begin
           ligne_dum:=ligne[i];
           ligne[i]:=ligne[j];
           ligne[j]:=ligne_dum;
         end;
       end;
     end;
   end;
//Deuxieme tri
   for i:=1 to nb_lignes_sort-1 do begin
     //label4.caption:='Second column';
     nb:=nb+1;
     progressbar1.position:=round(nb*100/(3*nb_lignes_sort-1));
     for j:=i+1 to nb_lignes_sort do begin
       case mode1 of
         1: z1:=ligne[i].sig;
         2: z1:=ligne[i].check;
         3: z1:=ligne[i].calc;
       end;
       case mode1 of
         1: z2:=ligne[j].sig;
         2: z2:=ligne[j].check;
         3: z2:=ligne[j].calc;
       end;
       if (z1 = z2) then begin
         case mode2 of
          1:begin
              x1:=ligne[i].sig;
              x2:=ligne[j].sig
            end;
          2:begin
              x1:=ligne[i].check;
              x2:=ligne[j].check;
           end;
          3:begin
              x1:=ligne[i].calc;
              x2:=ligne[j].calc;
            end;
         end;
         if (radiogroup2.itemIndex = 1)then begin
           if (x2 > x1)then begin
             ligne_dum:=ligne[i];
             ligne[i]:=ligne[j];
             ligne[j]:=ligne_dum;
           end;
         end else begin
           if (x1 > x2)then begin
             ligne_dum:=ligne[i];
             ligne[i]:=ligne[j];
             ligne[j]:=ligne_dum;
           end;
         end;
       end;
     end;
   end;
//Troisime tri
   for i:=1 to nb_lignes_sort-1 do begin
     //label4.caption:='Third column';
     nb:=nb+1;
     progressbar1.position:=round(nb*100/(3*nb_lignes_sort-1));
     for j:=i+1 to nb_lignes_sort do begin
       case mode1 of
         1: y1:=ligne[i].sig;
         2: y1:=ligne[i].check;
         3: y1:=ligne[i].calc;
       end;
       case mode1 of
         1: y2:=ligne[j].sig;
         2: y2:=ligne[j].check;
         3: y2:=ligne[j].calc;
       end;
       case mode2 of
         1: z1:=ligne[i].sig;
         2: z1:=ligne[i].check;
         3: z1:=ligne[i].calc;
       end;
       case mode2 of
         1: z2:=ligne[j].sig;
         2: z2:=ligne[j].check;
         3: z2:=ligne[j].calc;
       end;
       if (z1 = z2) and (y1 = y2) then begin
         case mode3 of
          1:begin
              x1:=ligne[i].sig;
              x2:=ligne[j].sig
            end;
          2:begin
              x1:=ligne[i].check;
              x2:=ligne[j].check;
           end;
          3:begin
              x1:=ligne[i].calc;
              x2:=ligne[j].calc;
            end;
         end;
         if (radiogroup3.itemIndex = 1)then begin
           if (x2 > x1)then begin
             ligne_dum:=ligne[i];
             ligne[i]:=ligne[j];
             ligne[j]:=ligne_dum;
           end;
         end else begin
           if (x1 > x2)then begin
             ligne_dum:=ligne[i];
             ligne[i]:=ligne[j];
             ligne[j]:=ligne_dum;
           end;
         end;
       end;
     end;
   end;
   if (provenance = 'unit1') then n:=89;
   if (provenance = 'truecell') or (provenance = 'lepage') then n:=54;
   for i:=1 to nb_lignes_sort do begin
     s:=ligne[i].chaine;

     if (i > 1) and (pos('ORTH',s) > 0) then begin
       s1:=copy(ligne[i-1].chaine,1,n);
       s2:=copy(s,1,n);
       if (s1 = s2)then begin
         delete(s,1,n);
         for j:=1 to n do s:=' '+s;
       end;
     end;
     listbox2.items[i]:=s;
     //writeln(nomf,ligne[i].chaine);
   end;
   //closefile(nomf);
   progressBar1.visible:=false;
   screen.cursor:=CRDefault;
end;

procedure Tfbsol_sort.BitBtn3Click(Sender: TObject);
//-------------------------------------------------
var
  nomf           : textfile;
  i,iwin         : integer;
  s              : string;
  CmdFile        : PChar;
begin
  if (fileexists('sort.tmp')) then deleteFile('sort.tmp');
  assignFile(nomf,'sort.tmp');
  rewrite(nomf);
  for i:=0 to nb_lignes_sort do begin
    s:=listbox2.items[i];
    writeln(nomf,s);
  end;
  closefile(nomf);
  CmdFile:='write.exe sort.tmp';
  iwin:=WinExec(CmdFile,5);
end;


end.
