unit main_litphil;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Menus;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Exit1: TMenuItem;
    Quitter1: TMenuItem;
    Ouvrir1: TMenuItem;
    Profilrd1: TMenuItem;
    Picsdi1: TMenuItem;
    Label1: TLabel;
    procedure sortie(Sender: TObject);
    procedure Picsdi1Click(Sender: TObject);
    procedure Profilrd1Click(Sender: TObject);
    procedure crea(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
procedure lit_fichier_id;
//----------------------
var
  i,j                                : integer;
  i2                                 : smallint;
  c2                                 : array[1..2]of char;
  c                                  : char;

  by                                 : byte;
  doub                               : double;
  wo                                 : word;
  annee,mois,jour                    : integer;
  x,y,w,bgrd                         : real;
  bitset,significance                : integer;
  s,nom_fichier,s1                   : string;
  nomf                               : file;
  ascfile                            : TextFile;
  version                            : string[2];
begin

with form1 do begin
 OpenDialog1.FilterIndex:=1;
 listbox1.clear;
 if OpenDialog1.execute then begin
   nom_fichier:=OpenDialog1.filename;
   if(length(nom_fichier) > 0)then  begin
     assignFile(nomf,nom_fichier);
     reset(nomf,1);
     assignFile(ascfile,'convert.out');
     rewrite(ascfile);

     {Revision}
      blockread(nomf,c2,2);                             //offset=2
      s:='';
      for i:=1 to 2 do begin
        s[i]:=c2[i];
      end;
      version:=s;
      listbox1.Items.add('Revision: '+s);

      //Type of data file
      blockread(nomf,c2,2);                             //offset=4
      s:='';
      for i:=1 to 2 do begin
        s[i]:=c2[i];
      end;
      listbox1.Items.add('Type of data file: '+s);

      for i:=1 to 80 do blockread(nomf,c,1);            //offset=84

      //Diffractometer type
      blockread(nomf,by,1);                             //offset=85
      case by of
       0: s:='PW1800';
       1: s:='PW1710 based system';
       2: s:='PW1840';
       3: s:='PW3710 based system';
       4: s:='Undefined';
       5: s:='X''Pert MPD';
      end;
      listbox1.Items.add('Diffractometer type: '+s);

      //Anode material
      blockread(nomf,by,1);                              //offset=86
      case by of
       0: s:='Cu';
       1: s:='Mo';
       2: s:='Co';
       3: s:='Fe';
       4: s:='Cr';
       5: s:='Other';
      end;
      listbox1.Items.add('Anode material: '+s);

      for i:=1 to 8 do blockread(nomf,c,1);               //offset=94

      //lambda1
      blockread(nomf,doub,8);                             //offset=102
      str(doub:8:5,s);
      listbox1.Items.add('lambda1: '+s);
      //lambda1
      blockread(nomf,doub,8);                             //offset=110
      str(doub:8:5,s);
      listbox1.Items.add('lambda2: '+s);
      //Ratio
      blockread(nomf,doub,8);                             //offset=118
      str(doub:8:3,s);
      listbox1.Items.add('Ratio: '+s);

      for i:=1 to 4 do blockread(nomf,c,1);               //offset=122

      //Date
      blockread(nomf,wo,2);                               //offset=124
      i:=wo;
      annee:=i div 512;
      i:=i-annee*512;
      mois:=i div 32;
      jour:=i-mois*32;
      s:='Date: ';
      str(jour:3,s1);
      s1:=trim(s1);
      s:=s+s1+'/';
      str(mois:2,s1);
      s1:=trim(s1);
      s:=s+s1+'/';
      str(annee:2,s1);
      s1:=trim(s1);
      s:=s+s1+'/';
      listbox1.Items.add(s);

      //Time
      blockread(nomf,wo,2);                               //offset=126
      str(wo:4,s);
      s:='Time of measurement: ';
      i:=wo div 60;
      j:=wo-i*60;
      str(i:3,s1);
      s:=s+s1+'H ';
      str(j:3,s1);
      s:=s+s1+'Mn';
      listbox1.Items.add(s);

      for i:=1 to 78 do blockread(nomf,c,1);               //offset=204

      //nb of peaks in .DI file
      blockread(nomf,i2,2);                                //offset=206
      str(i2:4,s);
      listbox1.Items.add('Number of peaks: '+s);

      for i:=1 to 44 do blockread(nomf,c,1);               //offset=250

      //Measurements
      s:='   Theta  width    Height   bgrd  sig bitset';
      listbox1.Items.add(s);
      while not(eof(nomf)) do begin
        blockread(nomf,i2,2);
        x:=i2/200;
        blockread(nomf,i2,2);
        w:=i2/200;
        blockread(nomf,i2,2);
        y:=i2;
        blockread(nomf,i2,2);
        bgrd:=i2;
        blockread(nomf,i2,2);
        significance:=i2 div 10;
        blockread(nomf,i2,2);
        bitset:=i2;

        s:='';
        str(x:8:2,s1);
        s:=s+s1;
        str(w:8:4,s1);
        s:=s+s1;
        str(y:8:1,s1);
        s:=s+s1;
        str(bgrd:8:1,s1);
        s:=s+s1;
        str(significance:4,s1);
        s:=s+s1;
        str(bitset:4,s1);
        s:=s+s1;
        listbox1.Items.add(s);
      end;
    end;
    CloseFile(nomf);
    CloseFile(ascFile);
  end;
end;

end;

procedure lit_fichier_rd;
//----------------------
var
  i                                  : integer;
  i2                                 : smallint;
  c2                                 : array[1..2]of char;
  c                                  : char;

  by                                 : byte;
  wo                                 : word;
  doub                               : double;
  theta_min,x,y,pas                  : real;
  n,nn                               : integer;
  s,nom_fichier,s1                   : string;
  nomf                               : file;
  ascfile                            : TextFile;
  version                            : string[2];
begin

with form1 do begin
 listbox1.clear;
 opendialog1.FilterIndex:=2;
 if OpenDialog1.execute then begin
   nom_fichier:=OpenDialog1.filename;
   if(length(nom_fichier) > 0)then  begin
     assignFile(nomf,nom_fichier);
     reset(nomf,1);
     assignFile(ascfile,'convert.out');
     rewrite(ascfile);

     {Revision}
      blockread(nomf,c2,2);                             //offset=2
      s:='';
      for i:=1 to 2 do begin
        s[i]:=c2[i];
      end;
      version:=s;
      listbox1.Items.add('Revision: '+s);

      //Type of data file
      blockread(nomf,c2,2);                             //offset=4
      s:='';
      for i:=1 to 2 do begin
        s[i]:=c2[i];
      end;
      listbox1.Items.add('Type of data file: '+s);

      for i:=1 to 80 do blockread(nomf,c,1);            //offset=84

      //Diffractometer type
      blockread(nomf,by,1);                             //offset=85
      case by of
       0: s:='PW1800';
       1: s:='PW1710 based system';
       2: s:='PW1840';
       3: s:='PW3710 based system';
       4: s:='Undefined';
       5: s:='X''Pert MPD';
      end;
      listbox1.Items.add('Diffractometer type: '+s);

      //Anode material
      blockread(nomf,by,1);                              //offset=86
      case by of
       0: s:='Cu';
       1: s:='Mo';
       2: s:='Co';
       3: s:='Fe';
       4: s:='Cr';
       5: s:='Other';
      end;
      listbox1.Items.add('Anode material: '+s);

      for i:=1 to 8 do blockread(nomf,c,1);               //offset=94

      //lambda1
      blockread(nomf,doub,8);                             //offset=102
      str(doub:8:5,s);
      listbox1.Items.add('lambda1: '+s);
      //lambda1
      blockread(nomf,doub,8);                             //offset=110
      str(doub:8:5,s);
      listbox1.Items.add('lambda2: '+s);
      //lambda1
      blockread(nomf,doub,8);                             //offset=118
      str(doub:8:3,s);
      listbox1.Items.add('Int. ratio: '+s);

      for i:=1 to 10 do blockread(nomf,c,1);               //offset=128

      //StepSize
      blockread(nomf,wo,2);                                //offset=130
      str(wo:8,s);
      listbox1.Items.add('StepSize: '+s);

      //Start angle
      blockread(nomf,wo,2);                                //offset=132
      str(wo:8,s);
      listbox1.Items.add('Start angle: '+s);

      //Final angle
      blockread(nomf,wo,2);                                 //offset=134
      str(wo:8,s);
      listbox1.Items.add('Final angle: '+s);

      for i:=1 to 80 do blockread(nomf,c,1);                //offset=214

      //StepSize
      blockread(nomf,doub,8);                               //offset=222
      str(doub:8:4,s);
      listbox1.Items.add('StepSize: '+s);
      //step_size:=doub;
      pas:=doub;

      //Start angle
      blockread(nomf,doub,8);                               //offset=230
      str(doub:8:4,s);
      listbox1.Items.add('Start angle: '+s);
      theta_min:=doub;

      //Final angle
      blockread(nomf,doub,8); //offset=238
      str(doub:8:4,s);
      listbox1.Items.add('Final angle: '+s);
      //theta_max:=doub;

     //   step_count:=round((theta_max-theta_min)/step_size);

      if (version = 'V5')then for i:=1 to 572 do blockread(nomf,c,1)
      else for i:=1 to 12 do blockread(nomf,c,1);           //offset=250 ou 810

      n:=0;
      nn:=0;
      s:='';
      while not(eof(nomf)) do begin
        n:=n+1;
        nn:=nn+1;
        s:='';blockread(nomf,i2,2);
        x:=theta_min+(n-1)*pas;
        str(x:8:3,s1);
        s:=s+s1;
        y:=sqr(i2*0.1);
        str(y:8:1,s1);
        s:=s+s1;
        listbox1.Items.add(s);
        write(ascfile,x:6:2,y:8:1);
        if (nn = 5)then begin
          nn:=0;
          writeln(ascfile);
          //listbox1.Items.add(s);
          //s:='';
        end;
      end;
      str(n:10,s);
      listbox1.Items.add('Nb de points:'+s);
    end;
    CloseFile(nomf);
    CloseFile(ascFile);
  end;
end;

end;

procedure TForm1.sortie(Sender: TObject);
begin
  close;
end;

procedure TForm1.Picsdi1Click(Sender: TObject);
begin
 lit_fichier_id;
end;

procedure TForm1.Profilrd1Click(Sender: TObject);
begin
 lit_fichier_rd;
end;

procedure TForm1.crea(Sender: TObject);
begin
  left:=0;
  top:=0;
end;

end.
