unit best_sol;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, checklst;

type
  Tfbest_sol = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SpeedButton1: TSpeedButton;
    Panel1: TPanel;
    Label5: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Panel2: TPanel;
    RadioGroup1: TRadioGroup;
    Edit7: TEdit;
    Label8: TLabel;
    Panel3: TPanel;
    Label1: TLabel;
    BitBtn3: TBitBtn;
    Label9: TLabel;
    Label10: TLabel;
    Edit6: TEdit;
    Edit8: TEdit;
    Memo2: TMemo;
    Memo3: TMemo;
    ListBox2: TListBox;
    CheckListBox1: TCheckListBox;
    Panel4: TPanel;
    Memo1: TMemo;
    BitBtn4: TBitBtn;
    Label11: TLabel;
    BitBtn8: TBitBtn;
    procedure sortie(Sender: TObject);
    procedure go_calcul(Sender: TObject);
    procedure init(Sender: TObject);
    procedure print_edit(Sender: TObject);
    procedure modif_tolerance(Sender: TObject);
    procedure onclick_checklist(Sender: TObject);
    procedure efface_panel4(Sender: TObject);
    procedure lit_tolerance(Sender: TObject; var Key: Char);
    procedure tri(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fbest_sol: Tfbest_sol;

implementation

uses
   mathhkl,unit3,unit3b,unit1,unit4,unit5,unit6, best_space, supple,
  bsol_sort;
var
  i20_min,i20_max,i20                              : integer;
  fom,fom_min,fom_max,volume,par_max,eps_maille    : real;
  tab_maille                                       : array[1..5000,1..3] of real;
  nb_mailles,nb_lignes                             : integer;

{$R *.DFM}

procedure Tfbest_sol.sortie(Sender: TObject);
//---------------------------------------
begin
  //form1.onclicklistbox4(Sender);
  //  close;
end;

procedure calcul(isol: integer; var ier:integer);
//------------------------------------------------
var
  s,s1                    : string;
  n,no,i                  : integer;
  maille                  : tab_reel;
  cel_old                 : array[1..6] of real;
begin

  with form1 do begin
    ier:=0;

//FOM et I20,  maille
    s:=listbox4.items[isol];
    delete(s,1,4);s:=trim(s);
    dec(s,maille,no,ier);
    if (ier > 0)then begin
      erreur('Parameters error');
      ier:=1;
      exit;
    end;

//test sur le paramtre maximum
    for i:=1 to 3 do begin
      if (maille[i+3] > par_max)then begin
        ier:=-1;
        exit;
      end;
    end;

//Test sur la rptition des mailles
    if (nb_mailles > 0) and (fbest_sol.radiogroup1.itemIndex = 1)then begin
     for i:=1 to nb_mailles do begin
        if (abs(tab_maille[i,1]-maille[4]) < eps_maille) and
        (abs(tab_maille[i,2]-maille[5]) < eps_maille) and
        (abs(tab_maille[i,3]-maille[6]) < eps_maille) then begin
          ier:=-1;
          exit;
        end;
      end;
    end;

    fom:=maille[2];
    i20:=round(maille[1]);
    volume:=maille[10];

//Test sur I20 et FOM
    if (i20 < i20_min) or (i20 > i20_max) or (fom < fom_min) then begin
      ier:=-1;
      exit;
    end;
    for i:=1 to 6 do begin
      cel_old[i]:=cel[i];
      cel[i]:=maille[i+3];
      cel_depart[i]:=maille[i+3];
    end;

//Systme
    quel_systeme;
    if (systeme = 'CUBI')then listbox1.itemIndex:=0;
    if (systeme = 'TETR')then listbox1.itemIndex:=1;
    if (systeme = 'ORTH')then listbox1.itemIndex:=2;
    if (systeme = 'HEXA')then listbox1.itemIndex:=3;
    if (systeme = 'RHOM')then listbox1.itemIndex:=4;
    if (systeme = 'MONO')then listbox1.itemIndex:=5;
    if (systeme = 'TRIC')then listbox1.itemIndex:=6;

//Test sur le systme cristallin
    if (fbest_sol.checklistbox1.state[0] = cbUnChecked) then begin
        if (fbest_sol.checklistbox1.state[listbox1.ItemIndex+1] = cbUnChecked)then begin
          for i:=1 to 6 do cel[i]:=cel_old[i];
          ier:=-1;
          exit;
        end;
    end;

//Groupes
    lit_affiche_groupes;
    listbox2.itemIndex:=0;
    groupe_espace:=listbox2.items[0];
    panel2.visible:=true;
    panel3.visible:=true;
    BitBtn6.visible:=true;
    BitBtn5.visible:=true;
    BitBtn4.visible:=true;
    calcul_raies_indx;
    //automatic_select;
    nb_mailles:=nb_mailles+1;
    if (nb_mailles > 5000)then begin
      beep;
      erreur('Too many cells (> 5000)');
      halt;
    end;
    for i:=1 to 3 do tab_maille[nb_mailles,i]:=cel[i];
  end;
end;

procedure Tfbest_sol.go_calcul(Sender: TObject);
//-------------------------------------------
type type_test =record
             count_ind,count_calc,no_sum : integer;
           end;

var
  s,s1                                                   : string;
  n,no,k,i_raie,ier,i,j,i_groupe,h,l,nb_indx_crsf,
  nb_raies_ind_max,nb_raies_calc_min,isol,premier        : integer;
  maille                                                 : tab_reel;
  ang_calc,ang_obs                                       : real;
  dist,dist_min                                          : real;
  nomf                                                   : TextFile;
  wo                                                     : word;
  test                                                   : array[1..50000] of ^type_test;
  sigma                                                  : double;

  nb_sol,n_index,n_index_max,n_calc,n_calc_min,
  nb_raies_calc,silence                                  : integer;
  w                                                      : word;


  i_setting,nb_setting,no_test,no_test1,    indexe_min   : integer;
const
   Osetting  : array[1..6] of string[4]= ('abc','cab','bca','a-cb','ba-c','-cba');

  label  1;
  label  2;

begin
  listbox2.items.clear;
  silence:=0;
  nb_lignes:=0;
  memo2.lines.clear;

  with fbest_sol do begin
    speedbutton1.down:=false;
    nb_mailles:=0;
    listbox2.clear;
    listbox2.Refresh;
    screen.cursor:=crHourGlass;
    if (nb_raies_dif = 0) then begin
      erreur('No measures lines');
      exit;
    end;

    if (nb_raies_indx = 0) then begin
      erreur('No calculated reflections');
      exit;
    end;

//Lecture des paramtres optionnels
    i20_min:=strtoint(edit1.text);
    i20_max:=strtoint(edit2.text);

    val(edit3.text,fom_min,ier);
    if (ier > 0)then begin
      erreur('Parameter error');
      edit3.setfocus;
      exit;
    end;

    val(edit4.text,tolerance,ier);
    if (ier > 0)then begin
      erreur('Parameter error');
      edit4.setfocus;
      exit;
    end;
    form1.edit26.text:=edit4.text;
    form1.edit37.text:=edit4.text;

    val(edit5.text,par_max,ier);
    if (ier > 0)then begin
      erreur('Parameter error');
      edit5.setfocus;
      exit;
    end;

    val(edit7.text,eps_maille,ier);
    if (ier > 0)then begin
      erreur('Parameter error');
      edit7.setfocus;
      exit;
    end;

    indexe_min:=strtoint(edit6.text);
    (*assignfile(nomf,'espion.txt');
    rewrite(nomf); *)

//boucle sur les solutions
    s:='Sol. I20  FOM   V/V1     a      b      c    alpha  beta   gamma'+
    '    Vol. Syst. Sp.Group Setting    Sigma    Checked  Calc.' ;
    memo2.Lines[0]:=s;
    listbox2.items.add(s);
    nb_lignes:=nb_lignes+1;

//******************************************************************************
    no_test:=0;
    nb_raies_ind_max:=0;
    nb_raies_calc_min:=1000000;
    for isol:=1 to nb_sol_crysfire do begin
      s:=copy(form1.listbox4.items[isol],5,3);
      nb_indx_crsf:=strtoint(s);  //Nb de raies indexes par Crysfire
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      calcul(isol,ier);
      if (ier = 1)then goto 2;                          // fin
      if (ier = -1)then continue;                       // La solution est saute
      s:=form1.ListBox4.items[isol];

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      for i_groupe:=1 to nb_groupes do begin
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//Click sur bouton Stop
        application.processmessages;
        if speedbutton1.Down then begin
          beep;
          wo:=messageDlg(' Do you want to stop the process?',
          mtConfirmation,mbYesNoCancel,0);
          if (wo= mryes)  then begin
             //fbest_sol.visible:=true;
             listbox2.items.add('Stopped by the user');
             nb_lignes:=nb_lignes+1;
             screen.cursor:=crdefault;
             speedbutton1.down:=false;
             form1.onclicklistbox4(sender);
             if (no_test > 0)then for l:=1 to no_test do dispose(test[l]);
             exit;
          end else begin
            speedbutton1.down:=false;
            fbest_sol.visible:=true;
          end;
        end;

        form1.listbox2.itemIndex:=i_groupe-1;
        s:=form1.listbox2.items[i_groupe-1];
        if(s = '')then break;

//Selection du groupe
        groupe_espace:=uppercase(s);
        if (systeme = 'TRIC') and (groupe_espace = 'P1')then continue;
        bravais:=copy(groupe_espace,1,1);
        if(systeme = 'RHOM')then bravais:='P';
        if (bravais = 'N')then bravais:='P'; //No. Ext
        decode_conditions(ier);

        Nb_setting:=1;
        if (systeme = 'ORTH') and  (nb_ligne_code > 0) then nb_setting:=6;
//*****************************************************************************
        premier:=1;
        for i_setting:=1 to nb_setting do begin
//*****************************************************************************
          for i:=1 to 3 do
          for j:=1 to 3 do r[i,j]:=Oabc[i_setting,i,j];

//*****************************************************************************
          nb_raies_calc:=0;
          for j:=1 to nb_raies_indx do begin
            with raies_indx[j] do begin
              h:=r[1,1]*hr+r[1,2]*kr+r[1,3]*lr;
              k:=r[2,1]*hr+r[2,2]*kr+r[2,3]*lr;
              l:=r[3,1]*hr+r[3,2]*kr+r[3,3]*lr;
              extinc(h,k,l,ier);
              ext:=ier;
              if (ier = 1) and (bravais = 'R')then begin
                extinc(k,h,l,ier);
                ext:=ier;
              end;
              if (ier = 0)then nb_raies_calc:=nb_raies_calc+1;
            end;
          end;

//recherche des raies calcules(indx) proches des raies dif
          nb_raies_obs:=0;
          for j:=1 to nb_raies_dif do begin
            dist_min:=1000;
            i_raie:=1;
            for k:=1 to nb_raies_indx do begin
              if (raies_indx[k].ext = 1)then continue;
              dist:=(theta_dif[j]-raies_indx[k].dtheta);
              if (dist < -tolerance)then continue;
              dist:=abs(dist);
              if (dist < dist_min)then begin
                ang_calc:=raies_indx[k].dtheta;
                ang_obs:=theta_dif[j];
                dist_min:=dist;
                i_raie:=k;
              end;
            end;
            if (dist_min > tolerance)then continue;

            nb_raies_obs:=nb_raies_obs+1;
            if (nb_raies_obs >= 1000) and (silence = 0) then begin
   w:=messageDlg('The Nb of calculated reflections is > 1000. Do you want to continue?',
   mtConfirmation,mbYesNoCancel,0);
   if (w = mrNo) or (w = mrAbort) then exit;
              //erreur('Too many reflections (> 1000)');
              nb_raies_obs:=nb_raies_obs-1;
              screen.cursor:=crdefault;
              goto 1;
            end;
            h_obs[nb_raies_obs]:=raies_indx[i_raie].hr;
            k_obs[nb_raies_obs]:=raies_indx[i_raie].kr;
            l_obs[nb_raies_obs]:=raies_indx[i_raie].lr;
            dtheta_obs[nb_raies_obs]:=ang_obs;
            dtheta_obs_cor[nb_raies_obs]:=ang_obs;
            dtheta_calc[nb_raies_obs]:=ang_calc;
            numero4:=j;
          end;

//Calcul de sigma
1:        if (nb_raies_obs < indexe_min)then continue;
          if (i_setting = 1) and (i_groupe = 1) and (nb_raies_obs < nb_indx_crsf) then begin
            beep;
            erreur('The angular tolerance has been set too fine ('+
            inttostr(nb_raies_obs)+'/'+inttostr(nb_indx_crsf)+')');
            screen.cursor:=crdefault;
            if (no_test > 0)then for l:=1 to no_test do dispose(test[l]);
            panel4.visible:=true;
            beep;
            exit;
          end;
          no_test:=no_test+1;
          if(no_test > 50000)then begin
            erreur('Too many test lines (> 50000)');
            screen.cursor:=crDefault;
            if (no_test > 0)then for l:=1 to no_test do dispose(test[l]);
            exit;
          end;
          new(test[no_test]);
          with test[no_test]^ do begin
            count_ind:=nb_raies_obs;
            count_calc:=nb_raies_calc;
          end;
          //writeln(nomf,no_test:5,count_raies_ind[no_test]:5, count_raies_calc[no_test]:5);
          n:=0;
          sigma:=0;
          for i:=1 to nb_raies_dif do begin
            ang_obs:=theta_dif[i];
            k:=0;
            for j:=1 to nb_raies_obs do begin
              if (abs(ang_obs-dtheta_calc[j]) < tolerance)then begin
                k:=j;
                n:=n+1;
                sigma:=sigma+sqr(ang_obs-dtheta_calc[j]);
                break;
              end;
            end;
          end;

//Ecriture dans le memo
          //solution
          s:=form1.listbox4.items[isol];
//systeme
          s:=s+' '+systeme;
          //groupe
          s1:=form1.listbox2.Items[i_groupe-1];
          if (length(s1) < 8)then for k:=length(s1) to 8  do s1:=s1+' ';
          s:=s+'  '+s1;
          //setting
          if (systeme = 'ORTH')then s1:=' '+Osetting[i_setting] else s1:=' ';
          if (length(s1) < 6)then for k:=length(s1) to 8  do s1:=s1+' ';
          s:=s+s1;
          //sigma
          str(sigma:8:5,s1);
          s:=s+s1+'  ';
          //nb de raies indexes
          str(n:5,s1);
          s:=s+s1+'  ';
          //nb de raies calcules
          str(nb_raies_calc:5,s1);
          s:=s+s1;
//si c'est le premier setting du groupe (premier = 1), on crit tout, sinon on efface 88 car.
          if (premier > 1)then for k:=1 to 88 do s[k]:=' ';
          if (premier = 1)then no_test1:=no_test;
          test[no_test]^.no_sum:=no_test1;
//ecriture
          listbox2.items.add(s);
          nb_lignes:=nb_lignes+1;
          listbox2.itemindex:=nb_lignes-1;
          premier:=premier+1;
//*****************************************************************************
        end
      end;
    end;
//*****************************************************************************

2:  fbest_sol.visible:=true;
    listbox2.items.add(' ');
    listbox2.items.add('Estimated best solution(s):');
    nb_lignes:=nb_lignes+2;
    form1.listbox4.itemindex:=isol-1;

//Meilleure solution
    if (no_test = 0)then begin
       listbox2.items.add('No solution. Modify the starting conditions');
       nb_lignes:=nb_lignes+1;
    end else begin
      nb_raies_ind_max:=0;
      for i:=1 to no_test do begin
        if (test[i]^.count_ind > nb_raies_ind_max)then
        nb_raies_ind_max:=test[i]^.count_ind;
      end;
      nb_raies_calc_min:=1000000;
      for i:=1 to no_test do begin
        if (test[i].count_ind = nb_raies_ind_max)then begin
          if (test[i]^.count_calc < nb_raies_calc_min)then
          nb_raies_calc_min:=test[i]^.count_calc;
        end;
      end;
      //writeln(nomf,'No_test=',no_test:5,' nb_raies_ind_max= ',
      //nb_raies_ind_max:5,' nb_raies_calc_min=',nb_raies_calc_min:5);
      for i:=1 to no_test do begin
       if (test[i]^.count_ind = nb_raies_ind_max) and
          (test[i]^.count_calc = nb_raies_calc_min) then begin
          s:=listbox2.items[i];
          s1:=listbox2.items[test[i]^.no_sum];
          //for j:=1 to 88 do s[i]:=s1[i];
          listbox2.items.add(s);
          nb_lignes:=nb_lignes+1;
          ier:=0;
        end;
      end;
    end;
    listbox2.itemindex:=nb_lignes-1;
    for i:=1 to no_test do dispose(test[i]);

//Affichage du dernier groupe, derniere solution
     quel_systeme;
     indx;
     efface_stringgrid1;ecrit_StringGrid1;
     ecrit_StringGrid5;
     ecrit_param_depart;
     automatic_select;
     screen.cursor:=crdefault;
     beep;
   end;
end;

procedure Tfbest_sol.init(Sender: TObject);
//--------------------------------------
var
  s              : string;
  fom_max        : real;
  i,no,ier       : integer;
  maille         : tab_reel;
begin
  checklistbox1.state[0]:=cbchecked;
  checklistbox1.ItemIndex:=0;
  if (nb_raies_dif < 20)then begin
    edit1.text:=inttostr(nb_raies_dif);
    edit2.text:=edit1.text;
  end;
  edit8.text:=inttostr(nb_raies_dif);
  if (edit6.text = '')then edit6.text:=edit8.text;
  if (edit4.text = '')then begin
    str(tolerance:6:3,s);
    edit4.text:=s;
  end;
  //listbox1.itemIndex:=0;
  fom_max:=0;
  fom_min:=100000;

//Recherche FOM max,fom_min et affichage si edit3.text=''
  for i:=1 to nb_sol_crysfire do begin
    with form1 do begin
      s:=listbox4.items[i];
      dec(s,maille,no,ier);
      if (maille[3] > fom_max)then fom_max:=maille[3];
      if (maille[3] < fom_min)then fom_min:=maille[3];
    end;
  end;
  if (edit3.text = '')then begin
    str(fom_min:7:2,s);
    edit3.text:=s;
  end;
end;

procedure Tfbest_sol.print_edit(Sender: TObject);
//--------------------------------------------
var
    CmdFile      : Pchar;
    iwin,i       : integer;
    nomf         : TextFile;
begin
  assignFile(nomf,'listbox2.tmp');
  rewrite(nomf);
  writeln(nomf,extractFilename(nom_fichier_sum));
  for i:=1 to nb_lignes do writeln(nomf,listbox2.items[i-1]);
  CloseFile(nomf);
  CmdFile:='write.exe listbox2.tmp';
  iwin:=WinExec(CmdFile,5);
end;

procedure Tfbest_sol.modif_tolerance(Sender: TObject);
//-------------------------------------------------
var
  s           : string;
  ier         : integer;
begin
  s:=trim(edit4.text);
  val(s,tolerance,ier);
  if (ier > 0)then begin
    erreur('Read error on tolerance');
    edit4.Focused;
    exit;
  end;
  //s:=trim(edit4.text);

//modification de l'affichage de la tolrance
  fbest_sol.edit4.text:=s;
  fbest_space.edit3.text:=s;
  fsupple.edit4.text:=s;
  form1.Edit37.text:=s;
  form1.Edit26.text:=s;

end;

procedure Tfbest_sol.onclick_checklist(Sender: TObject);
//---------------------------------------------------
var
  i              : integer;
begin
  with checklistbox1 do begin
    if (itemindex = 0) then begin
      for i:=1 to 7 do state[i]:=cbunchecked;
      state[0]:=cbchecked;
    end else begin
      state[0]:=cbunchecked;
    end;
  end;
end;

procedure Tfbest_sol.efface_panel4(Sender: TObject);
//--------------------------------------------------
begin
  panel4.visible:=false;
end;

procedure Tfbest_sol.lit_tolerance(Sender: TObject; var Key: Char);
//-----------------------------------------------------------------
begin
  if (ord(key) = 13)then modif_tolerance(sender);
end;

procedure Tfbest_sol.tri(Sender: TObject);
//----------------------------------------
var
  i   : integer;
  s   : string;
begin
  if (nb_lignes <= 0)then exit;
  if (nb_lignes > 9998)then begin
    erreur('Too many solutions!');
    exit;
  end;
  fbsol_sort.listbox2.clear;
  nb_lignes_sort:=0;
  s:=fbest_sol.listbox2.items[0];
  fbsol_sort.listbox2.Items.add(s);
  for i:=1 to nb_lignes do begin
    s:=fbest_sol.listbox2.items[i];
    if (trim(s) = '')then break;
    fbsol_sort.listbox2.Items.add(s);
    nb_lignes_sort:=nb_lignes_sort+1;
  end;
  fbsol_sort.visible:=true;
end;

end.
