unit lilambda;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  Tflilambda = class(TForm)
    Panel14: TPanel;
    Label45: TLabel;
    Label61: TLabel;
    Label64: TLabel;
    Label66: TLabel;
    Label44: TLabel;
    BitBtn8: TBitBtn;
    Edit51: TEdit;
    Edit54: TEdit;
    Edit57: TEdit;
    ListBox3: TListBox;
    procedure lit_lambda(Sender: TObject);
    procedure clicklistbox(Sender: TObject);
    procedure initialise(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  flilambda: Tflilambda;
  dif_raw  : integer;

implementation

{$R *.DFM}
uses
  mathhkl, unit1,unit2,unit4,unit5,unit6;

procedure Tflilambda.lit_lambda(Sender: TObject);
//-------------------------------------------
var
  ier      : integer;
  x        : real;
  s,s1                                     :string;
  i,numero_anode                           : integer;
const
  type_anode : array[1..5] of string[2]= ('Mo','Cu','Co','Fe','Cr');
  wl1 : array[1..5]of real = (0.70930,1.54056,1.78897,1.93339,2.28970);
  wl2 : array[1..5]of real = (0.71359,1.54439,1.79285,1.93730,2.29361);
  wl  : array[1..5]of real = (0.71070,1.54180,1.79020,1.93604,2.29090);
begin
  case dif_raw of
  1:begin
      s:=edit57.text;
      val(s,x,ier);
      if (ier > 0)then begin
        erreur('Lambda error!');
        exit;
      end;
      lambda_dif:=x;
      s:=edit51.text;
      if (s ='')then s:='0';
      val(s,lambda1_dif,ier);
      if (ier > 0)then begin
        erreur('Lambda1 error!');
        exit;
      end;
      s:=edit54.text;
      val(s,lambda2_dif,ier);
      if (s ='')then s:='0';
      if (ier > 0)then begin
        erreur('Lambda2 error!');
        exit;
      end;
      ratio_dif:=0.50;
      if (listbox3.itemindex = -1)then begin
        lambda1_dif:=0;
        lambda2_dif:=0;
        anode_dif:='?';
        ratio_dif:=1;
      end;
      ecrit_paneau20;
      efface_stringgrid2;
      ecrit_stringGrid2;
      ecrit_stringgrid4;
      efface_stringgrid3;
      efface_stringGrid6;
      efface_stringGrid8;
      nb_raies_obs:=0;
      flilambda.visible:=false;
      lecture_mesures(numero_fichier_dif);
    end;
  2:begin
     s:=edit57.text;
     val(s,x,ier);
     if (ier > 0)then begin
       erreur('Lambda error!');
       exit;
     end;
     lambda_raw:=x;
     s:=edit51.text;
     if (s ='')then s:='0';
     val(s,lambda1_raw,ier);
     if (ier > 0)then begin
       erreur('Lambda1 error!');
       exit;
     end;
     s:=edit54.text;
     val(s,lambda2_raw,ier);
     if (s ='')then s:='0';
     if (ier > 0)then begin
       erreur('Lambda2 error!');
       exit;
     end;
     ratio_raw:=0.50;

     if (listbox3.itemindex = -1)then begin
       lambda1_raw:=0;
       lambda2_raw:=0;
       anode_raw:='?';
       ratio_raw:=1;
     end;
      //wl1 et/ou wl2 n'ont pas t lus
     if (lambda1_raw = 0) or (lambda2_raw = 0) and (anode_raw <> '')then begin
       s1:=anode_raw;s1:=uppercase(s1);
       for i:=1 to 5 do begin
         s:=type_anode[i];s:=uppercase(s);
         if (s = s1)then begin
           lambda1_raw:=wl1[i];
           lambda2_raw:=wl2[i];
           if (ratio_raw = 0)then ratio_raw:=0.50;
           break;
         end;
       end;
     end;

     //wl n'a pas t lu
     if (lambda_raw = 0) and (lambda1_raw > 0) then
     lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw);

     //La nature de l'anode n'a pas t lue
     anode_raw:=trim(anode_raw);
     if (anode_raw ='') or (anode_raw = '?')then begin
       numero_anode:=0;
       if (lambda_raw > 0)then begin
         for i:=1 to 5 do begin
           if (abs(lambda_raw-wl[i]) < 0.01)then begin
             numero_anode:=i;
             break;
           end;
         end;
       end;
       if (numero_anode > 0)then
       anode_raw:=type_anode[numero_anode] else anode_raw:='?';
     end;
     if (ratio_raw = 0) and (anode_raw <> '')then ratio_raw:=0.5;
     //La L.O. est-elle diffrente de la L.O. courante?
     if (lambda_dif = 0)then begin
       lambda:=lambda_raw;
       lambda1:=lambda1_raw;
       lambda2:=lambda2_raw;
       ratio:=ratio_raw;
       theta_min:=theta_min_raw;
       theta_max:=theta_max_raw;
       theta_min_depart:=theta_min_raw;
       theta_max_depart:=theta_max_raw;
       ecrit_paneau19;
     end else begin
       if (abs(lambda_raw-lambda_dif) > 0.01)then begin
         erreur('The wavelength read in the file is different from'+
         ' the wavelength of the measured peaks');
         exit;
       end;
     end;
     //Apparition du paneau 21
     flilambda.visible:=false;
     ecrit_paneau21;
     dessin;
   end;
  end;
end;

procedure Tflilambda.clicklistbox(Sender: TObject);
//---------------------------------------------
var
  i,ier   : integer;
  s   : string;
const
  type_anode : array[1..5] of string[2]= ('Mo','Cu','Co','Fe','Cr');
  wl1 : array[1..5]of real = (0.70930,1.54056,1.78897,1.93339,2.28970);
  wl2 : array[1..5]of real = (0.71359,1.54439,1.79285,1.93730,2.29361);
  wl  : array[1..5]of real = (0.71070,1.54180,1.79020,1.93604,2.29090);
begin
  i:=Listbox3.ItemIndex+1;
  label44.visible:=true;edit57.visible:=true;
  if (i > -1) and (i < 6)then begin
    label61.visible:=true;label64.visible:=true;
    edit51.visible:=true;edit54.visible:=true;
    if (dif_raw =1 )then begin
      anode_dif:=type_anode[i];
      lambda1_dif:=wl1[i];
      lambda2_dif:=wl2[i];
      lambda_dif:=wl[i];
      str(lambda1_dif:8:5,s);
      edit51.text:=s;
      str(lambda2_dif:8:5,s);
      edit54.text:=s;
      str(lambda_dif:8:5,s);
      edit57.text:=s;
      anode_dif:=type_anode[i];
    end else begin
      anode_raw:=type_anode[i];
      lambda1_raw:=wl1[i];
      lambda2_raw:=wl2[i];
      lambda_raw:=wl[i];
      str(lambda1_raw:8:5,s);
      edit51.text:=s;
      str(lambda2_raw:8:5,s);
      edit54.text:=s;
      str(lambda_raw:8:5,s);
      edit57.text:=s;
      anode_raw:=type_anode[i];
    end;
  end;
  if (i = 6) then begin
    label61.visible:=false;label64.visible:=false;
    edit51.visible:=false;edit54.visible:=false;
    edit51.text:='0';
    edit54.text:='0';
    if (dif_raw = 1)then anode_raw:='Xx' else anode_dif:='Xx';
  end;
  edit57.setfocus;
end;

procedure Tflilambda.initialise(Sender: TObject);
//-----------------------------------------------
begin
  listbox3.ItemIndex:=-1;
  label61.visible:=false;label64.visible:=false;label44.visible:=false;
  edit51.visible:=false;edit54.visible:=false;edit57.visible:=false;
  edit51.text:='0';edit54.text:='0';
end;

end.
