unit regresse;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, stdhdr, gj, mulreg, math;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure sortie(Sender: TObject);
    procedure Programme(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.sortie(Sender: TObject);
begin
  close;
end;

procedure TForm1.Programme(Sender: TObject);
VAR
    nomf               : textfile;
    xp                 : array[0..50]of real;
    n_points           : integer;

    storedata:          recmat;
    y:              LongVector;
    eqncoef,coefsig:    shortVector;
    numobs, numiv, i:   integer;
    error:              boolean;
    yest, resid:        longVector;
    rsq,  r:            real;
    see:                real;
    lambda,theta,h,k,l,dhkl  : real;
    hh,kk,ll,th  :array[0..50] of real;
    a_moy        : real;
BEGIN
     lambda:=1.54056;

     AssignFile(nomf,'data.inp');
     reset(nomf);
     n_points:=-1;
     r:=0;
     while not eof(nomf) do begin
       n_points:=n_points+1;
       readln(nomf,h,k,l,theta);
       hh[n_points]:=h;
       kk[n_points]:=k;
       ll[n_points]:=l;
       th[n_points]:=theta;
       theta:=0.5*theta/57.2957;
       xp[n_points]:=sqr(cos(theta));
       dhkl:=lambda/(2*sin(theta));
       y[n_points]:=dhkl*sqrt(h*h+k*k+l*l);
     end;
     closefile(nomf);

     for i:=0 to n_points do begin
       storedata[i,0]:=1;
       storedata[i,1]:=xp[i]*xp[i];
     end;

     assignfile(nomf,'intpo.txt');
     rewrite(nomf);
     a_moy:=0;
     for i:=0 to n_points-1 do  a_moy:=a_moy+y[i];
     a_moy:=a_moy/n_points;
     r:=0;
     for i:=0 to n_points-1 do begin
       dhkl:=a_moy/sqrt(hh[i]*hh[i]+kk[i]*kk[i]+ll[i]*ll[i]);
       theta:=2*57.2957*arcsin(lambda/(2*dhkl));
       writeln(nomf,hh[i]:3:0,kk[i]:3:0,ll[i]:3:0,th[i]:8:3,theta:8:3,(th[i]-theta):12:5);
       r:=r+sqr(th[i]-theta);
     end;
     r:=sqrt(r)/n_points;
     writeln(nomf,'Avant: ',r:10:7);

      numobs := n_points;
      numiv := 2;

      MultipleReg(storedata,y,numiv,numobs,eqncoef,yest,resid,
             see,coefsig,rsq,r,error);

      for i:=0 to numobs-1 do
      writeln(nomf,y[i]:15:4,yest[i]:15:4,resid[i]:15:5);
      writeln(nomf);
      writeln(nomf);
      for i:=0 to numiv do  writeln(nomf,eqncoef[i]:10:5,coefsig[i]:15:8);
      r:=0;
      for i:=0 to n_points do begin
        dhkl:=eqncoef[0]/sqrt(sqr(hh[i])+sqr(kk[i])+sqr(ll[i]));
        theta:=2*57.2957*arcsin(lambda/(2*dhkl));
        writeln(nomf,hh[i]:3:0,kk[i]:3:0,ll[i]:3:0,th[i]:8:3,theta:8:3,(th[i]-theta):12:5);
        r:=r+sqr(th[i]-theta);
      end;
      r:=sqrt(r)/(n_points-1);
      writeln(nomf,'Apres: ',r:10:7);
      closefile(nomf);
end;

end.
