unit supercell;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Grids, math, ColorBtns;

type
  Tfsupercell = class(TForm)
    RadioGroup1: TRadioGroup;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    StringGrid1: TStringGrid;
    Label1: TLabel;
    BitBtn4: TBitBtn;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    RadioGroup4: TRadioGroup;
    RadioGroup5: TRadioGroup;
    Bevel1: TBevel;
    Label3: TLabel;
    Label7: TLabel;
    Label25: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label12: TLabel;
    Label2: TLabel;
    Label14: TLabel;
    Label16: TLabel;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit1: TEdit;
    Bevel2: TBevel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label15: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    Edit20: TEdit;
    Edit21: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label13: TLabel;
    Label19: TLabel;
    Bevel3: TBevel;
    Color95Button1: TColor95Button;
    procedure sortie(Sender: TObject);
    procedure init(Sender: TObject);
    procedure click_setting1(Sender: TObject);
    procedure go_tranforme(Sender: TObject);
    procedure peint_stringgrid1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ok_replace(Sender: TObject);
    procedure ok_add(Sender: TObject);
    procedure supercell_setting2(Sender: TObject);
    procedure spercell_setting3(Sender: TObject);
    procedure supercell_setting4(Sender: TObject);
    procedure supercell_setting5(Sender: TObject);
    procedure sortie_gamma(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fsupercell: Tfsupercell;

implementation

{$R *.DFM}
uses
   mathhkl,unit1;

var
  Oabc                                      : array[1..6,1..3,1..3] of real;
  Mabc                                      : array[1..3,1..3,1..3] of integer;
  cel_new                                   : array[1..6] of real;
  vol,v_mult,v_new                          : real;

procedure Tfsupercell.sortie(Sender: TObject);
//-------------------------------------------
begin
  close;
end;

procedure ecrit_set1(var n:integer);
//----------------------------------
var
  s             : string;
begin
//Affichage de la matrice unit
 with fsupercell.stringgrid1 do begin
   str(oabc[n,1,1]:8:4,s); cells[0,0]:=s;
   str(oabc[n,1,2]:8:4,s); cells[0,1]:=s;
   str(oabc[n,1,3]:8:4,s); cells[0,2]:=s;
   str(oabc[n,2,1]:8:4,s); cells[1,0]:=s;
   str(oabc[n,2,2]:8:4,s); cells[1,1]:=s;
   str(oabc[n,2,3]:8:4,s); cells[1,2]:=s;
   str(oabc[n,3,1]:8:4,s); cells[2,0]:=s;
   str(oabc[n,3,2]:8:4,s); cells[2,1]:=s;
   str(oabc[n,3,3]:8:4,s); cells[2,2]:=s;
 end;
end;

procedure Tfsupercell.init(Sender: TObject);
//-------------------------------------------
var
 i,j           : integer;
 s             : string;
 ca,cb,cc      : real;
begin
 edit16.text:='';edit17.text:='';edit18.text:='';
 edit19.text:='';edit20.text:='';edit21.text:='';
 edit2.text:=''; edit3.text:='';
(* if (systeme <> 'ORTH')
 then fsupercell.radiogroup1.visible:=false else radiogroup1.visible:=true;
 *)
 for i:=1 to 3 do begin
  for j:=1 to 3 do begin
    Oabc[1,i,j]:=0;
    Oabc[2,i,j]:=0;
    Oabc[3,i,j]:=0;
    Oabc[4,i,j]:=0;
    Oabc[5,i,j]:=0;
    Oabc[6,i,j]:=0;
    Mabc[1,i,j]:=0;
    Mabc[2,i,j]:=0;
    Mabc[2,i,j]:=0;
  end;
end;
Oabc[1,1,1]:=1;Oabc[1,2,2]:=1;Oabc[1,3,3]:=1;
Oabc[2,1,3]:=1;Oabc[2,2,1]:=1;Oabc[2,3,2]:=1;
Oabc[3,1,2]:=1;Oabc[3,2,3]:=1;Oabc[3,3,1]:=1;
Oabc[4,1,1]:=1;Oabc[4,2,3]:=-1;Oabc[4,3,2]:=1;
Oabc[5,1,2]:=1;Oabc[5,2,1]:=1;Oabc[5,3,3]:=-1;
Oabc[6,1,3]:=-1;Oabc[6,2,2]:=1;Oabc[6,3,1]:=1;

//Affichage de la matrice
i:=1;ecrit_set1(i);

//Affichage de la maille
 str(cel[1]:8:4,s);edit10.text:=s;
 str(cel[2]:8:4,s);edit11.text:=s;
 str(cel[3]:8:4,s);edit12.text:=s;
 str(cel[4]:8:2,s);edit13.text:=s;
 str(cel[5]:8:2,s);edit14.text:=s;
 str(cel[6]:8:2,s);edit15.text:=s;

//Affichage du volume
 ca:=cos(cel[4]/57.2957);
 cb:=cos(cel[5]/57.2957);
 cc:=cos(cel[6]/57.2957);
 vol:=cel[1]*cel[2]*cel[3]*sqrt(1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc);
 str(vol:10:2,s);edit1.text:=s;

//Affichage du systme
 if (systeme = 'CUBI')then s:='Cubic';
 if (systeme = 'TETR')then s:='Tetragonal';
 if (systeme = 'ORTH')then s:='Orthorhombic';
 if (systeme = 'HEXA')then s:='Hexagonal';
 if (systeme = 'RHOM')then s:='Rhomboedral';
 if (systeme = 'MONO')then s:='Monoclinic';
 if (systeme = 'TRIC')then s:='Triclinic';
 label16.caption:=s;
 radiogroup1.ItemIndex:=0;
end;

procedure search_syst(var no_psys: integer);
//-----------------------------------------
var
  dif1,dif2,dif3,epsa,epsb,a,b,c,alpha,beta,gamma          : real;
begin
 epsa:=0.03;
 epsb:=0.005;
 a:=cel_new[1];
 b:=cel_new[2];
 c:=cel_new[3];
 alpha:=cel_new[4];
 beta:=cel_new[5];
 gamma:=cel_new[6];
 //psys:='';
 no_psys:=7;
 dif1:=abs(a-b);
 dif2:=abs(b-c);
 dif3:=abs(c-a);
//Cubique, quadratique, orthorhombique
 if (abs(alpha-90) < epsa) and (abs(beta-90) < epsa) and (abs(gamma-90) < epsa)then begin
   if (dif1 < epsb) and (dif2 < epsb) and (dif3 < epsb) then begin
     //psys:='CUBI';
     no_psys:=1;
     exit;
   end;
   if (dif1 < epsb) and (dif2 > epsb) then begin
     //psys:='TETR';
     no_psys:=2;
     exit;
   end;
   if (dif1 > epsb) and (dif2 > epsb) then begin
     //psys:='ORTH';
     no_psys:=3;
     exit;
   end;
 end;
//Hexagonal
 if (dif1        < epsb)  and
 (abs(alpha-90)  < epsa)  and
 (abs(beta-90)   < epsa)  and
 (abs(gamma-120) < epsa)  then begin
   //psys:='HEXA';
   no_psys:=4;
   exit;
 end;
//Rhomboedrique
 if (dif1 < epsb)       and (dif2 < epsb)         and (dif3 < epsb)   and
 (abs(alpha-beta) < epsa) and (abs(beta-gamma) < epsa) and (abs(gamma-alpha) < epsa) then begin
   //psys:='RHOM';
   no_psys:=5;
   exit;
 end;
//Monoclinique
 if (abs(alpha-90) < epsa) and (abs(gamma-90)< epsa) and (abs(beta-90)> epsa)then begin
   //psys:='MONO';
   no_psys:=6;
   exit;
 end;
end;

procedure relit_maille;
//---------------------
var
  s             : string;
  ier           : integer;
  ca,cb,cc,vol  : real;
begin
with fsupercell do begin
  s:=edit10.text;
  //if(s = '')then exit;
  verif(s);
  val(s,cel[1],ier);
  if(ier <> 0)then begin
    erreur('Error on a');
    exit;
  end;
  s:=edit11.text;
  //if(s = '')then exit;
  verif(s);
  val(s,cel[2],ier);
  if(ier <> 0)then begin
    erreur('Error on b');
    exit;
  end;
  s:=edit12.text;
  //if(s = '')then exit;
  verif(s);
  val(s,cel[3],ier);
  if(ier <> 0)then begin
    erreur('Error on c');
    exit;
  end;
  s:=edit13.text;
  //if(s = '')then exit;
  verif(s);
  val(s,cel[4],ier);
  if(ier <> 0)then begin
    erreur('Error on alpha');
    exit;
  end;
  s:=edit14.text;
  //if(s = '')then exit;
  verif(s);
  val(s,cel[5],ier);
  if(ier <> 0)then begin
    erreur('Error on beta');
    exit;
  end;
  s:=edit15.text;
  //if(s = '')then exit;
  verif(s);
  val(s,cel[6],ier);
  if(ier <> 0)then begin
    erreur('Error on gamma');
    exit;
  end;
  setmat;
  quel_systeme;
  if (systeme = 'CUBI')then s:='Cubic';
  if (systeme = 'TETR')then s:='Tetragonal';
  if (systeme = 'ORTH')then s:='Orthorhombic';
  if (systeme = 'HEXA')then s:='Hexagonal';
  if (systeme = 'RHOM')then s:='Rhomboedral';
  if (systeme = 'MONO')then s:='Monoclinic';
  if (systeme = 'TRIC')then s:='Triclinic';
  label16.caption:=s;
  ca:=cos(cel[4]/57.2957);
  cb:=cos(cel[5]/57.2957);
  cc:=cos(cel[6]/57.2957);
  vol:=cel[1]*cel[2]*cel[3]*sqrt(1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc);
  str(vol:10:2,s);edit1.text:=s;
end;
end;

procedure Tfsupercell.go_tranforme(Sender: TObject);
//--------------------------------------------------
var
  m               : matrice3;
  s               : string;
  i,j,ier,no_psys : integer;
  x,ca,cb,cc      : real;
  v0,v21,v22,v23  : vecteur3;
begin
  relit_maille;
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      s:=stringGrid1.cells[j-1,i-1];s:=trim(s);
      val(s,x,ier);
      if (ier > 0)then begin
        erreur('Read Error in '+inttostr(i)+','+inttostr(j));
        exit;
      end;
      m[i,j]:=x;
    end;
  end;

//a
  v0[1]:=m[1,1];v0[2]:=m[1,2];v0[3]:=m[1,3];
  trfo4(v0,v21,r20);
  cel_new[1]:=sqrt(v21[1]*v21[1]+v21[2]*v21[2]+v21[3]*v21[3]);
//b
  v0[1]:=m[2,1];v0[2]:=m[2,2];v0[3]:=m[2,3];
  trfo4(v0,v22,r20);
  cel_new[2]:=sqrt(v22[1]*v22[1]+v22[2]*v22[2]+v22[3]*v22[3]);
//a
  v0[1]:=m[3,1];v0[2]:=m[3,2];v0[3]:=m[3,3];
  trfo4(v0,v23,r20);
  cel_new[3]:=sqrt(v23[1]*v23[1]+v23[2]*v23[2]+v23[3]*v23[3]);
//Angles
  ca:=(v22[1]*v23[1]+v22[2]*v23[2]+v22[3]*v23[3])/(cel_new[2]*cel_new[3]);
  cb:=(v23[1]*v21[1]+v23[2]*v21[2]+v23[3]*v21[3])/(cel_new[3]*cel_new[1]);
  cc:=(v21[1]*v22[1]+v21[2]*v22[2]+v21[3]*v22[3])/(cel_new[1]*cel_new[2]);
  cel_new[4]:=57.2957*arccos(ca);
  cel_new[5]:=57.2957*arccos(cb);
  cel_new[6]:=57.2957*arccos(cc);

//Test sur le volume
 v_new:=cel_new[1]*cel_new[2]*cel_new[3]*sqrt(1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc);
 if (abs(v_new) < 0.1)then begin
   erreur('The Vol = 0. Coplanar vectors?');
   exit;
 end;

//Affichage de la nouvelle maille
 str(cel_new[1]:8:4,s);edit16.text:=s;
 str(cel_new[2]:8:4,s);edit17.text:=s;
 str(cel_new[3]:8:4,s);edit18.text:=s;
 str(cel_new[4]:8:2,s);edit19.text:=s;
 str(cel_new[5]:8:2,s);edit20.text:=s;
 str(cel_new[6]:8:2,s);edit21.text:=s;

//Affichage du volume
 str(v_new:10:2,s);edit2.text:=s;

//Affichage de V1/V0 rapport des mailles;
 v_mult:=v_new/vol;
 str(v_mult:8:2,s);edit3.text:=s;

//Affichage du systme
 search_syst(no_psys);
 case no_psys of
  1: s:='Cubic';
  2: s:='Tetragonal';
  3: s:='Orthorhombic';
  4: s:='Hexagonal';
  5: s:='Trigonal';
  6: s:='Monoclinic';
  7: s:='Triclinic';
 end;
 label17.visible:=true;
 label17.caption:=s;
end;

procedure Tfsupercell.peint_stringgrid1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//---------------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
  s:=stringgrid1.cells[col,row];
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfsupercell.ok_replace(Sender: TObject);
//-----------------------------------------------var
var
 i                : integer;
 s,s1             : string;
 x                : real;
begin
  for i:=1 to 6 do cel[i]:=cel_new[i];
  quel_systeme;
  s:=form1.listbox4.items[form1.listbox4.ItemIndex];
  s1:=copy(s,16,5);s1:=trim(s);
  val(s1,x,i);
  x:=x*v_mult;
  s:=copy(s,1,15);
  str(x:5:2,s1);
  s:=s+s1+' ';
  for i:=1 to 3 do begin
    str(cel[i]:7:3,s1);
    s:=s+s1;
  end;
  for i:=4 to 6 do begin
    str(cel[i]:7:2,s1);
    s:=s+s1;
  end;
  if (v_new < 100000)then str(v_new:9:1,s1) else str(v_new:9:0,s1);
  s:=s+s1;
  form1.listbox4.items[form1.listbox4.ItemIndex]:=s;

//Mise  jour de Crysum
  crysum[1]:=crysum[form1.listbox4.itemindex];
  with crysum[1] do begin
    liste:=s;
    for i:=1 to 6 do maille[i]:=cel[i];
    syst:=systeme;
    vv1:=x;
    vol:=v_new;
  end;

//=Click sur la nouvelle solution dans form1
  form1.onclicklistbox4(Sender);
  form1.label56.caption:='List modified by Cell Transf.';
end;

procedure Tfsupercell.ok_add(Sender: TObject);
//--------------------------------------------
var
 i                : integer;
 s,s1             : string;
 x                : real;
 crysum1          : summary;
begin
  if (edit16.text = '')then begin
    beep;
    erreur('No transformed cell');
    exit;
  end;
  for i:=1 to 6 do cel[i]:=cel_new[i];
  quel_systeme;
  s:=form1.listbox4.items[form1.listbox4.ItemIndex];
  s1:=copy(s,16,5);s1:=trim(s);
  val(s1,x,i);
  x:=x*v_mult;
  s:=copy(s,1,15);
  str(x:5:2,s1);
  s:=s+s1+' ';
  for i:=1 to 3 do begin
    //str(cel[i]:9:3,s1);
    if (cel[i] < 100)then str(cel[i]:7:3,s1) else str(cel[i]:7:2,s1);
    s:=s+s1;
  end;
  for i:=4 to 6 do begin
    str(cel[i]:7:2,s1);
    s:=s+s1;
  end;
  if (v_new < 100000)then str(v_new:9:1,s1) else str(v_new:9:0,s1);
  s:=s+s1;
  for i:=1 to 4 do s[i]:=' ';
  s[4]:='0';

//Mise  jour de crysum
  crysum1:=crysum[form1.listbox4.itemindex];
  with crysum1 do begin
    num:=0;
    liste:=s;
    for i:=1 to 6 do maille[i]:=cel[i];
    syst:=systeme;
    vv1:=x;
    vol:=v_new;
  end;

//Insertion de la ligne
  with form1.listbox4 do begin
    items.add('*');
    for i:= nb_sol_crysfire downto 1 do BEGIN
      CRYSUM[I+1]:=crysum[i];
      items[i+1]:=items[i];
    end;
    items[1]:=s;
    crysum[1]:=crysum1;
  end;
  nb_sol_crysfire:=nb_sol_crysfire+1;

//=Click sur la nouvelle solution dans form1
  form1.onclicklistbox4(Sender);
  form1.label56.caption:='List modified by Cell Transf.';
  close;
end;

procedure efface_transformee;
begin
  with fsupercell do begin
    edit2.text:='';
    edit3.text:='';
    edit16.text:='';
    edit17.text:='';
    edit18.text:='';
    edit19.text:='';
    edit20.text:='';
    edit21.text:='';
  end;
end;

procedure Tfsupercell.click_setting1(Sender: TObject);
//---------------------------------------------------
var
  i : integer;
begin
  efface_transformee;
  //radiogroup1.itemindex:=-1;
  radiogroup2.itemindex:=-1;
  radiogroup3.itemindex:=-1;
  radiogroup4.itemindex:=-1;
  radiogroup5.itemindex:=-1;
  i:=radiogroup2.itemindex+1;
  i:=radiogroup4.itemindex+1;
  i:=radiogroup1.itemindex+1;
  ecrit_set1(i)
end;

procedure ecrit_set2(var n:integer);
//----------------------------------
  const
  m1    :array[1..9] of integer = (-1,0,0,0,-1,1,0,1,1);
  m2    :array[1..9] of integer = (-1,0,1,0,-1,0,1,0,1);
  m3    :array[1..9] of integer = (1,1,0,1,-1,0,0,0,1);
  m4    :array[1..9] of integer = (0,1,1,1,0,1,1,1,0);
  m5    :array[1..9] of integer = (-1,1,1,1,-1,1,1,1,-1);
var
  m     : array[1..9] of integer;
  i,j   : integer;
begin
//Affichage de la matrice unit
 case n of
   1: for i:=1 to 9 do m[i]:=m1[i];
   2: for i:=1 to 9 do m[i]:=m2[i];
   3: for i:=1 to 9 do m[i]:=m3[i];
   4: for i:=1 to 9 do m[i]:=m4[i];
   5: for i:=1 to 9 do m[i]:=m5[i];
 end;

 with fsupercell.stringgrid1 do begin
   for j:=0 to 2 do cells[j,0]:=inttostr(m[j+1]);
   for j:=0 to 2 do cells[j,1]:=inttostr(m[j+4]);
   for j:=0 to 2 do cells[j,2]:=inttostr(m[j+7]);
 end;
end;

procedure Tfsupercell.supercell_setting2(Sender: TObject);
//--------------------------------------------------------
var
  i : integer;
begin
  efface_transformee;
  radiogroup1.itemindex:=-1;
//radiogroup2.itemindex:=-1;
  radiogroup3.itemindex:=-1;
  radiogroup4.itemindex:=-1;
  radiogroup5.itemindex:=-1;
  i:=radiogroup2.itemindex+1;
  ecrit_set2(i)
end;

procedure ecrit_set3(var n:integer);
//----------------------------------
  const
  m1    :array[1..9] of real = (-1,0,0,0,-0.5,0.5,0,0.5,0.5);
  m2    :array[1..9] of real = (-0.5,0,0.5,0,-1,0,0.5,0,0.5);
  m3    :array[1..9] of real = (0.5,0.5,0,0.5,-0.5,0,0,0,-1);
  m4    :array[1..9] of real = (-0.5,0.5,0.5,0.5,-0.5,0.5,0.5,0.5,-0.5);
  m5    :array[1..9] of real = (0,0.5,0.5,0.5,0,0.5,0.5,0.5,0);
var
  m     : array[1..9] of real;
  i,j   : integer;
  s     : string;
begin
//Affichage de la matrice unit
 case n of
   1: for i:=1 to 9 do m[i]:=m1[i];
   2: for i:=1 to 9 do m[i]:=m2[i];
   3: for i:=1 to 9 do m[i]:=m3[i];
   4: for i:=1 to 9 do m[i]:=m4[i];
   5: for i:=1 to 9 do m[i]:=m5[i];
 end;

 with fsupercell.stringgrid1 do begin
   for j:=0 to 2 do begin
     str(m[j+1]:4:1,s);
     cells[j,0]:=s;
   end;
   for j:=0 to 2 do begin
     str(m[j+4]:4:1,s);
     cells[j,1]:=s;
   end;
   for j:=0 to 2 do begin
     str(m[j+7]:4:1,s);
     cells[j,2]:=s;
   end;
 end;
end;

procedure Tfsupercell.spercell_setting3(Sender: TObject);
//---------------------------------------------------
var
  i : integer;
begin
  efface_transformee;
  radiogroup1.itemindex:=-1;
  radiogroup2.itemindex:=-1;
//  radiogroup3.itemindex:=-1;
  radiogroup4.itemindex:=-1;
  radiogroup5.itemindex:=-1;
  i:=radiogroup2.itemindex+1;
  i:=radiogroup3.itemindex+1;
  ecrit_set3(i)
end;

procedure ecrit_set4(var n:integer);
//----------------------------------
  const
  m1    :array[1..9] of real = (0.666666, 0.33333, 0.33333,
                               -0.333333, 0.33333, 0.33333,
                               -0.333333,-0.66666, 0.33333);
  m2    :array[1..9] of real = (1,-1,0,0,1,-1,1,1,1);
var
  m     : array[1..9] of real;
  i,j   : integer;
  s     : string;
begin
 case n of
   1: for i:=1 to 9 do m[i]:=m1[i];
   2: for i:=1 to 9 do m[i]:=m2[i];
 end;

 with fsupercell.stringgrid1 do begin
   for j:=0 to 2 do begin
     str(m[j+1]:8:5,s);
     cells[j,0]:=s;
   end;
   for j:=0 to 2 do begin
     str(m[j+4]:8:5,s);
     cells[j,1]:=s;
   end;
   for j:=0 to 2 do begin
     str(m[j+7]:8:5,s);
     cells[j,2]:=s;
   end;
 end;
end;

procedure Tfsupercell.supercell_setting4(Sender: TObject);
//---------------------------------------------------
var
  i : integer;
begin
  efface_transformee;
  radiogroup1.itemindex:=-1;
  radiogroup2.itemindex:=-1;
  radiogroup3.itemindex:=-1;
//radiogroup4.itemindex:=-1;
  radiogroup5.itemindex:=-1;
  i:=radiogroup2.itemindex+1;
  i:=radiogroup4.itemindex+1;
  ecrit_set4(i)
end;

procedure ecrit_set5(var n:integer);
//----------------------------------
const
  m    :array[1..9] of integer = (-1,0,0,0,-1,0,0,0,1);
var
  i,j   : integer;
begin
 with fsupercell.stringgrid1 do begin
   for j:=0 to 2 do cells[j,0]:=inttostr(m[j+1]);
   for j:=0 to 2 do cells[j,1]:=inttostr(m[j+4]);
   for j:=0 to 2 do cells[j,2]:=inttostr(m[j+7]);
 end;
end;

procedure Tfsupercell.supercell_setting5(Sender: TObject);
//---------------------------------------------------
var
  i  : integer;
begin
  efface_transformee;
  radiogroup1.itemindex:=-1;
  radiogroup2.itemindex:=-1;
  radiogroup3.itemindex:=-1;
  radiogroup4.itemindex:=-1;
//  radiogroup5.itemindex:=-1;
  i:=radiogroup2.itemindex+1;
  i:=radiogroup5.itemindex+1;
  ecrit_set5(i)
end;

procedure Tfsupercell.sortie_gamma(Sender: TObject);
//--------------------------------------------------
begin
  relit_maille;
end;

end.
