//Acquisition des paramtres
unit unit3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Graphics,
  Controls, StdCtrls, dialogs, math;


procedure efface_stringGrid1;
procedure ecrit_stringgrid1;
procedure numero_case;
procedure verif_frappe;
procedure couleur_edit_param;
procedure get_nom_systeme;
procedure calcul_indx;
procedure ecrit_maille;
procedure relit_data;
procedure calcul_raies_indx;
procedure lit_affiche_groupes;

implementation

uses unit1,mathhkl,unit3b,unit5,unit4, unit6;

var
  no_case                 : integer;


procedure efface_stringGrid1;
//---------------------------
var
  i,j  : integer;
begin
  with form1.stringGrid1 do begin
       for I := 0 to ColCount - 1 do
      for J:= 0 to RowCount - 1 do Cells[I,J] := '';
  end;
end;

procedure relit_data;
{-------------------}
var
   ier,i   : integer;
   s      : string;
begin
  //systeme:='';
  i:=form1.listbox1.itemIndex;
  if (i <> -1)then begin
    systeme:=copy(form1.listbox1.items[i],1,4);
    systeme:=uppercase(systeme);
  end;
  groupe_espace:='';
  i:=form1.listbox2.itemIndex;
  if(i <> -1)then begin
    groupe_espace:=form1.listbox2.items[i];
    groupe_espace:=uppercase(groupe_espace);
    groupe_espace:=trim(groupe_espace);
  end;

  s:=form1.edit1.text;
  if(s = '')then exit;
  verif(s);
  val(s,cel[1],ier);
  if(ier <> 0)then begin
    erreur('Error on a');
    exit;
  end;
  s:=form1.edit2.text;
  if(s = '')then exit;
  verif(s);
  val(s,cel[2],ier);
  if(ier <> 0)then begin
    erreur('Error on b');
    exit;
  end;
  s:=form1.edit3.text;
  if(s = '')then exit;
  verif(s);
  val(s,cel[3],ier);
  if(ier <> 0)then begin
    erreur('Error on c');
    exit;
  end;
  s:=form1.edit4.text;
  if(s = '')then exit;
  verif(s);
  val(s,cel[4],ier);
  if(ier <> 0)then begin
    erreur('Error on alpha');
    exit;
  end;
  s:=form1.edit5.text;
  if(s = '')then exit;
  verif(s);
  val(s,cel[5],ier);
  if(ier <> 0)then begin
    erreur('Error on beta');
    exit;
  end;
  s:=form1.edit6.text;
  if(s = '')then exit;
  verif(s);
  val(s,cel[6],ier);
  if(ier <> 0)then begin
    erreur('Error on gamma');
    exit;
  end;

  s:=form1.edit7.text;
  if(s = '')then exit;
  verif(s);
  val(s,lambda,ier);
  if(ier <> 0)then begin
    erreur('Error on lambda');
    exit;
  end;
  s:=form1.edit30.text;
  if(s = '')then exit;
  verif(s);
  val(s,theta_min,ier);
  if(ier <> 0)then begin
    erreur('Error on theta_min');
    exit;
  end;
  s:=form1.edit31.text;
  if(s = '')then exit;
  verif(s);
  val(s,theta_max,ier);
  if(ier <> 0)then begin
    erreur('Error on theta_max');
    exit;
  end;
  if (form1.radiogroup1.ItemIndex = 0) then begin
    theta_min:=2*theta_min;
    theta_max:=2*theta_max;
  end;
   if (theta_min_depart > theta_min)then theta_min_depart:=theta_min;
   if (theta_max_depart < theta_max)then theta_max_depart:=theta_max;
  ecrit_paneau19;
end;

//Evnement OnEnter dans les cases EDIT
procedure numero_case;
//--------------------
begin
  efface_stringGrid1;
  efface_stringGrid5;
  efface_par_affines;
  with form1 do begin
    if edit1.focused then no_case:=1;
    if edit2.focused then no_case:=2;
    if edit3.focused then no_case:=3;
    if edit4.focused then no_case:=4;
    if edit5.focused then no_case:=5;
    if edit6.focused then no_case:=6;
  end;
end;

//Evenement onExit dans les cases edit
procedure verif_frappe;
//---------------------
var
  s                : string;
  x                : real;
  ier              : integer;
begin
  with form1 do begin

    case no_case of
      1: s:=edit1.text;
      2: s:=edit2.text;
      3: s:=edit3.text;
      4: s:=edit4.text;
      5: s:=edit5.text;
      6: s:=edit6.text;
    end;
    verif(s);
    val(s,x,ier);
    if (ier > 0)then begin
      case no_case of
        1: edit1.setfocus;
        2: edit2.setfocus;
        3: edit3.setfocus;
        4: edit4.setfocus;
        5: edit5.setfocus;
        6: edit6.setfocus;
      end;
      erreur ('Type error!');
      exit;
    end;

    case no_case of
      1:begin
        if (systeme = 'CUBI') then begin
          edit2.text:=s;
          edit3.text:=s;
        end;
        if (systeme = 'TETR') or (systeme = 'HEXA') then edit2.text:=s;
        if (systeme = 'RHOM') then begin
          edit2.text:=s;
          edit3.text:=s;
        end;
        cel[1]:=x;
      end;
      2: cel[2]:=x;
      3: cel[3]:=x;
      4:begin
          cel[4]:=x;
          if (systeme = 'RHOM') then begin
            edit5.text:=s;
            edit6.text:=s;
            cel[5]:=x;
            cel[6]:=x;
          end;
        end;
    end;

  end;
end;

//Coloration des cases paramtres suivant le Systme
procedure couleur_edit_param;{
-----------------------------}
begin
    with form1 do begin
      //edit1.text:='';edit2.text:='';edit3.text:='';
      //edit4.text:='';edit5.text:='';edit6.text:='';
      edit1.color:=clwhite;
      edit2.color:=clwhite;
      edit3.color:=clwhite;
      edit4.color:=clwhite;
      edit5.color:=clwhite;
      edit6.color:=clwhite;
          checkbox1.checked:=false;
          checkbox1.enabled:=false;
          checkbox2.checked:=false ;
          checkbox2.enabled:=false;
          checkbox3.checked:=false;
          checkbox3.enabled:=false;
          checkbox4.checked:=false;
          checkbox4.enabled:=false;
          checkbox5.checked:=false;
          checkbox5.enabled:=false;
          checkbox6.checked:=false;
          checkbox6.enabled:=false;
          checkbox7.checked:=false;
          checkbox7.enabled:=true;
          checkbox8.checked:=false;
          checkbox8.enabled:=true;
      if(systeme = 'CUBI')then begin
          edit2.color:=clsilver;
          edit3.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='90';
          edit2.text:=edit1.text;edit3.text:=edit1.text;
          checkbox1.enabled:=true;
          checkbox1.checked:=true;
       end else if (systeme = 'TETR')then begin
          edit2.color:=clsilver;
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='90';
          edit2.text:=edit1.text;
          checkbox1.enabled:=true;
          checkbox1.checked:=true;
          checkbox3.enabled:=true;
          checkbox3.checked:=true;
      end else if (systeme  = 'ORTH')then begin
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='90';
          checkbox1.enabled:=true;
          checkbox1.checked:=true;
          checkbox2.enabled:=true;
          checkbox2.checked:=true;
          checkbox3.enabled:=true;
          checkbox3.checked:=true;
      end else if (systeme = 'HEXA') then begin
          edit2.color:=clsilver;
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='120';
          edit2.text:=edit1.text;
          checkbox1.enabled:=true;
          checkbox1.checked:=true;
          checkbox3.enabled:=true;
          checkbox3.checked:=true;
     end else If (systeme = 'RHOM') then begin
          edit2.color:=clsilver;
          edit3.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit2.text:=edit1.text;edit3.text:=edit1.text;
          edit5.text:=edit4.text;edit6.text:=edit4.text;
          checkbox1.enabled:=true;
          checkbox1.checked:=true;
          checkbox4.enabled:=true;
          checkbox4.checked:=true;
     end else if(systeme = 'MONO')then begin
          edit4.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit6.text:='90';
          checkbox1.enabled:=true;
          checkbox1.checked:=true;
          checkbox2.enabled:=true;
          checkbox2.checked:=true;
          checkbox3.enabled:=true;
          checkbox3.checked:=true;
          checkbox5.enabled:=true;
          checkbox5.checked:=true;
      end else if(systeme = 'TRIC')then begin
          checkbox1.enabled:=true;
          checkbox1.checked:=true;
          checkbox2.enabled:=true;
          checkbox2.checked:=true;
          checkbox3.enabled:=true;
          checkbox3.checked:=true;
          checkbox4.enabled:=true;
          checkbox4.checked:=true;
          checkbox5.enabled:=true;
          checkbox5.checked:=true;
          checkbox6.enabled:=true;
          checkbox6.checked:=true;
     end;
    end;
end;

//Ecriture de la maille dans les cases edit
procedure ecrit_maille;
//---------------------
var
  s   : string;
begin
  with form1 do begin
    str(cel[1]:8:4,s);
    edit1.text:=s;
    str(cel[2]:8:4,s);
    edit2.text:=s;
    str(cel[3]:8:4,s);
    edit3.text:=s;
    str(cel[4]:8:3,s);
    edit4.text:=s;
    str(cel[5]:8:3,s);
    edit5.text:=s;
    str(cel[6]:8:3,s);
    edit6.text:=s;
  end;
end;

//Lit les groupes dans les fichiers pos et les affiche dans ListBox2
procedure lit_affiche_groupes;
//----------------------------
var
  s,s1                    : string;
  nomf                    : TextFile;
begin
  s1:=repertoire_origine+'\'+systeme+'.pos';
  if (systeme ='QUAD')then s1:=repertoire_origine+'\'+'TETR.pos';

  if (systeme = 'ORTH')then begin
    form1.label44.visible:=true;
    form1.listbox3.visible:=true;
  end else begin
    form1.label44.visible:=false;
    form1.listbox3.visible:=false;
  end;
  if (form1.listbox3.itemindex = -1)then form1.listbox3.itemindex:=0;
  no_setting:=form1.listbox3.itemindex+1;

  modif_attrib(s1);
  AssignFile(nomf,s1);
  reset(nomf);

  form1.listbox2.visible:=true;
  form1.listbox2.items.clear;
  nb_groupes:=0;
//  form1.listbox2.items.add('No ext.');

  while not (eof(nomf)) do begin
    readln(nomf,s);
    s:=TrimRight(s);
    if(length(s) = 0)then begin
      readln(nomf,s);
      s:=trim(s);
      form1.listbox2.items.add(s);
      if(s <> '')then nb_groupes:=nb_groupes+1;
    end;
  end;
  closeFile(nomf);
end;

//Allume le groupe et le systme slectionns
procedure allume_groupes;{
-------------------------}
var
  s                       : string;
  i                       : integer;
begin
  bravais:=copy(groupe_espace,1,1);
  if(systeme = 'RHOM')then bravais:='P';
  s:=groupe_espace;s:=trim(s);s:=uppercase(s);
  if (s = 'NO EXT.')then begin
    groupe_espace:=form1.listbox2.Items[0];
    nb_ligne_code:=0;
  end;

//Allumage du systeme
  for i:=1 to 7 do begin
    s:=copy(form1.listbox1.items.strings[i-1],1,4);
    s:=uppercase(s);
    if(s = systeme)then begin
      form1.listbox1.ItemIndex:=i-1;
      break;
    end;
  end;

//Allumage du groupe d'espace dans listbox2
  if(length(groupe_espace) > 0)then begin
    for i:=1 to nb_groupes do begin
      s:=form1.listbox2.items.strings[i-1];
      s:=Trim(s);
      if(groupe_espace = s) then begin
        form1.listbox2.ItemIndex:=i-1;
        break;
      end;
    end;
  end;
end;

procedure ecrit_stringGrid1;
//--------------------------
var
  i,j,n,h,k,l,ier: integer;
  s,s1,s2                  : string;
  nomf                     : textfile;
  xraie                    : raie;
begin
  efface_stringGrid1;
  with form1.stringgrid1 do begin
    if (nb_raies_indx < 15)then begin
      rowcount:=15;
    end else begin
      rowcount:=nb_raies_indx+nb_raies_indx_eteint+1;
    end;
    cells[0,0]:='  h   k   l';
    cells[1,0]:='   Dhkl';
    if (form6.radiogroup1.ItemIndex = 1)
    then cells[2,0]:='2Theta' else cells[2,0]:='Theta';

    ier:=0;
    n:=0;
//raies teintes on ajoute raies_indx et raies_indx_eteint et on met en ordre
    if (form6.speedbutton2.down = false) then begin
    //if (form6.checkbox1.State = cbchecked) then begin
      s:='Calc. diagram (+ forbidden lines)';
      form1.label22.left:=(-form1.canvas.textwidth(s)+form1.panel3.width) div 2;
      form1.label22.caption:=s;
      nb_somme:=nb_raies_indx+nb_raies_indx_eteint;
      for i:=1 to nb_raies_indx do raies_somme[i]:=raies_indx[i];
      for i:=1 to nb_raies_indx_eteint do raies_somme[i+nb_raies_indx]:=raies_indx_eteint[i];
      for i:=1 to nb_somme-1 do begin
        for j:=i+1 to nb_somme do begin
          if (raies_somme[i].dtheta > raies_somme[j].dtheta)then begin
            xraie:=raies_somme[i];
            raies_somme[i]:=raies_somme[j];
            raies_somme[j]:=xraie;
          end;
        end;
      end;

      for i:=1 to nb_somme do begin
        with raies_somme[i] do begin
          n:=n+1;
          str(hr:3,s);
          str(kr:3,s1);
          str(lr:3,s2);
          s:=s+s1+s2;
          cells[0,n]:=s;
          str(dr:7:4,s);
          cells[1,n]:=s;
          if (form6.radiogroup1.ItemIndex = 1) then str(dtheta:7:3,s)
          else str((dtheta/2):7:3,s);
          cells[1+1,n]:=s;
        end;
      end;
    end else begin
      s:='Calulated diagram';
      form1.label22.left:=(-form1.canvas.textwidth(s)+form1.panel3.width) div 2;
      form1.label22.caption:=s;
      for i:=1 to nb_raies_indx do begin
        with raies_indx[i] do begin
          n:=n+1;
          str(hr:3,s);
          str(kr:3,s1);
          str(lr:3,s2);
          s:=s+s1+s2;
          cells[0,n]:=s;
          str(dr:7:4,s);
          cells[1,n]:=s;
          if (form6.radiogroup1.ItemIndex = 1) then str(dtheta:7:3,s)
          else str((dtheta/2):7:3,s);
          cells[1+1,n]:=s;
        end;
      end;
    end;
  end;
  form1.edit27.text:=inttostr(n);
end;

procedure calcul_indx;
//-------------------
var
  p             : real;
  i             : integer;
begin
  with form1 do begin
    PageControl1.activepage:=TabSheet2;
    relit_data;
    if (lambda = 0)then begin
      erreur
      ('The wavelength =0');
      exit;
    end;
    p:=1;
    for i:=1 to 6 do p:=p*cel[i];
    if (p = 0)then begin
      erreur('Cell parameters error!');
      exit;
    end;
    if (systeme = '')then begin
      erreur('No system!');
      exit;
    end;
    if (groupe_espace = '')then begin
      erreur('No space group!');
      exit;
    end;
    if (theta_max_depart <= theta_min_depart)then begin
      erreur ('Theta range error');
      exit;
    end;
////////////////////////////////////
    indx;
///////////////////////////////////
    BitBtn4.visible:=true;
    lambda_indx:=lambda;
    theta_min_indx:=theta_min_depart;
    theta_max_indx:=theta_max_depart;
  end;
end;

procedure calcul_raies_indx;
//--------------------------
var
  s              : string;
  i              : integer;
begin
  with form1 do begin
    lit_affiche_groupes;
    allume_groupes;
    couleur_edit_param;
    ecrit_maille;
    ecrit_param_depart;
    str(lambda:8:5,s);
    edit7.text:=s;
    if (form1.radiogroup1.ItemIndex = 0)then begin
      str(0.5*theta_min:7:2,s);
      edit30.text:=s;
      str(0.5*theta_max:7:2,s);
      edit31.text:=s;
    end else begin
      str(theta_min:7:2,s);
      edit30.text:=s;
      str(theta_max:7:2,s);
      edit31.text:=s;
    end;
    nb_raies_obs:=0;
    relit_data;

   if (lambda > 0) and (theta_max > 0)then begin
      calcul_indx;
      ecrit_stringgrid1;
      ecrit_stringGrid5;
      BitBtn4.visible:=true;
    end;
   (* s:='Calc. diagram';
    s:=trim(s);
    i:=canvas.textWidth(s);
    label22.left:=(panel3.width -i) div 4;
    label22.caption:=s; *)

    if (lambda = 0) or (theta_max = 0)then erreur(
    'Lambda or Angle limits not defined. Type the values and press Calc. button');
  end;
  dessin;
end;

procedure get_nom_systeme;
//------------------------
begin
  with form1 do begin
    systeme:=copy(listbox1.items[listbox1.itemIndex],1,4);
    systeme:=uppercase(systeme);
    lit_affiche_groupes;
    couleur_edit_param;
    if (listbox3.itemindex = -1)then listbox3.itemindex:=0;
    no_setting:=listbox3.itemindex;
  end;
end;

end.
